function [P,so,VV,v,iter]=DLT(ximage,Xground,limit,maxiter)
% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% December 2004
% ximage=[x1 y1;x2 y2;...;xn yn]
% Xground=[X1 Y1 Z1;...;Xn Yn Zn]

for i=1:size(ximage,1)

    L(2*i-1,1)=ximage(i,1);
    L(2*i,1)=ximage(i,2);

    A(2*i-1,1)=Xground(i,1);
    A(2*i-1,2)=Xground(i,2);
    A(2*i-1,3)=Xground(i,3);
    A(2*i-1,4)=1;
    A(2*i-1,9)=-Xground(i,1)*ximage(i,1);
    A(2*i-1,10)=-Xground(i,2)*ximage(i,1);
    A(2*i-1,11)=-Xground(i,3)*ximage(i,1);

    A(2*i,5)=Xground(i,1);
    A(2*i,6)=Xground(i,2);
    A(2*i,7)=Xground(i,3);
    A(2*i,8)=1;
    A(2*i,9)=-Xground(i,1)*ximage(i,2);
    A(2*i,10)=-Xground(i,2)*ximage(i,2);
    A(2*i,11)=-Xground(i,3)*ximage(i,2);

end
dx=inv(A'*A)*(A'*L);

iter=1;
so1=1;so2=200000;
while abs((so2-so1)/so1)>limit
    if iter>=maxiter-1
        break
    end

    so1=so2;
    
    for i=1:size(ximage,1)

        X=Xground(i,1);
        Y=Xground(i,2);
        Z=Xground(i,3);

        dif_x_dx1=X/(dx(9)*X+dx(10)*Y+dx(11)*Z+1);
        dif_x_dx2=Y/(dx(9)*X+dx(10)*Y+dx(11)*Z+1);
        dif_x_dx3=Z/(dx(9)*X+dx(10)*Y+dx(11)*Z+1);
        dif_x_dx4=1/(dx(9)*X+dx(10)*Y+dx(11)*Z+1);
        dif_x_dx5=0;
        dif_x_dx6=0;
        dif_x_dx7=0;
        dif_x_dx8=0;
        dif_x_dx9=-(dx(1)*X+dx(2)*Y+dx(3)*Z+dx(4))/(dx(9)*X+dx(10)*Y+dx(11)*Z+1)^2*X;
        dif_x_dx10=-(dx(1)*X+dx(2)*Y+dx(3)*Z+dx(4))/(dx(9)*X+dx(10)*Y+dx(11)*Z+1)^2*Y;
        dif_x_dx11=-(dx(1)*X+dx(2)*Y+dx(3)*Z+dx(4))/(dx(9)*X+dx(10)*Y+dx(11)*Z+1)^2*Z;

        dif_y_dx1=0;
        dif_y_dx2=0;
        dif_y_dx3=0;
        dif_y_dx4=0;
        dif_y_dx5=X/(dx(9)*X+dx(10)*Y+dx(11)*Z+1);
        dif_y_dx6=Y/(dx(9)*X+dx(10)*Y+dx(11)*Z+1);
        dif_y_dx7=Z/(dx(9)*X+dx(10)*Y+dx(11)*Z+1);
        dif_y_dx8=1/(dx(9)*X+dx(10)*Y+dx(11)*Z+1);
        dif_y_dx9=-(dx(5)*X+dx(6)*Y+dx(7)*Z+dx(8))/(dx(9)*X+dx(10)*Y+dx(11)*Z+1)^2*X;
        dif_y_dx10=-(dx(5)*X+dx(6)*Y+dx(7)*Z+dx(8))/(dx(9)*X+dx(10)*Y+dx(11)*Z+1)^2*Y;
        dif_y_dx11=-(dx(5)*X+dx(6)*Y+dx(7)*Z+dx(8))/(dx(9)*X+dx(10)*Y+dx(11)*Z+1)^2*Z;


        % Design Matrix A
        A(2*i-1,1)=dif_x_dx1;
        A(2*i-1,2)=dif_x_dx2;
        A(2*i-1,3)=dif_x_dx3;
        A(2*i-1,4)=dif_x_dx4;
        A(2*i-1,5)=dif_x_dx5;
        A(2*i-1,6)=dif_x_dx6;
        A(2*i-1,7)=dif_x_dx7;
        A(2*i-1,8)=dif_x_dx8;
        A(2*i-1,9)=dif_x_dx9;
        A(2*i-1,10)=dif_x_dx10;
        A(2*i-1,11)=dif_x_dx11;

        A(2*i,1)=dif_y_dx1;
        A(2*i,2)=dif_y_dx2;
        A(2*i,3)=dif_y_dx3;
        A(2*i,4)=dif_y_dx4;
        A(2*i,5)=dif_y_dx5;
        A(2*i,6)=dif_y_dx6;
        A(2*i,7)=dif_y_dx7;
        A(2*i,8)=dif_y_dx8;
        A(2*i,9)=dif_y_dx9;
        A(2*i,10)=dif_y_dx10;
        A(2*i,11)=dif_y_dx11;

        % Observation Matrix
        tempx=(dx(1)*X+dx(2)*Y+dx(3)*Z+dx(4))/(dx(9)*X+dx(10)*Y+dx(11)*Z+1);
        tempy=(dx(5)*X+dx(6)*Y+dx(7)*Z+dx(8))/(dx(9)*X+dx(10)*Y+dx(11)*Z+1);

        L(2*i-1,1)=ximage(i,1)-tempx;
        L(2*i,1)=ximage(i,2)-tempy;

    end

    % Least Squares Solution
    dx_iter=inv(A'*A)*(A'*L);
    dx=dx+dx_iter;
    iter=iter+1;

    v=L-A*dx_iter;
    so2=sqrt(v'*v/(2*size(ximage,1)-11));
end
so=so2;
VV=so^2*inv(A'*A);
dx(12,1)=1;
P=reshape(dx,4,3)';

