function [exterior,interior]=P_2_KRT(P)
% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% December 2004
% exterior=[Xo Yo Zo omega phi kappa]
% interior=[c xo yo]
% Compute Exterior and Interior from DLT


exterior=-inv(P(:,1:3))*P(:,4);
Xo=exterior(1);
Yo=exterior(2);
Zo=exterior(3);

omega=atan(-P(3,2)/P(3,3));
phi=atan(-sin(omega)*(P(3,1)/P(3,2)));

r31=sin(phi);
r32=-sin(omega)*cos(phi);
r33=cos(omega)*cos(phi);
B=-(r31*Xo+r32*Yo+r33*Zo);

xo=(P(1,1)*P(3,1)+P(1,2)*P(3,2)+P(1,3)*P(3,3))*B^2;
yo=(P(2,1)*P(3,1)+P(2,2)*P(3,2)+P(2,3)*P(3,3))*B^2;

cx=sqrt(-xo^2+((P(1,1))^2+(P(1,2))^2+(P(1,3))^2)*B^2);
cy=sqrt(-yo^2+((P(2,1))^2+(P(2,2))^2+(P(2,3))^2)*B^2);
c=(cx+cy)/2;

kappa=atan(-cx*(yo*P(3,1)-P(2,1)))/(cy*(xo*P(3,1)-P(1,1)));
exterior=[Xo Yo Zo omega phi kappa];
interior=[c xo yo];
