function [absol,so,VV,v,iter]=absolute(absol_initial,model,Xground,limit,maxiter)
% exterior=[Xo Yo Zo omega phi kappa]
% model=[x1 y1 z1;...;xn yn zn]
% Xground=[X1 Y1 Z1;...;Xn Yn Zn]
% limit=[linear angular] convergence limits ie:[0.001(m) 0.000001(rad)]
% absol=[k OMEGA PHI KAPPA tx ty tz];
% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% October 2003


absol=absol_initial';

iter=0;
% To enter the first loop
dX=[1+limit(1) 1+limit(2) 1+limit(2) 1+limit(2) 1+limit(1) 1+limit(1) 1+limit(1)]; 

while (max(abs(dX(2:4)))>=limit(2) | max(abs(dX(5:7)))>=limit(1))  
    if iter>=maxiter-1 
        break
    end
    
    k=absol(1);
    omega=absol(2); 
    phi=absol(3); 
    kappa=absol(4);
    tx=absol(5);
    ty=absol(6);
    tz=absol(7);
    
    for i=1:size(model,1)
        
        X=Xground(i,1);
        Y=Xground(i,2);
        Z=Xground(i,3);
        x=model(i,1);
        y=model(i,2);
        z=model(i,3);

        difX_k=cos(kappa)*cos(phi)*x-sin(kappa)*cos(phi)*y+sin(phi)*z;
        difY_k=(cos(kappa)*sin(phi)*sin(omega)+sin(kappa)*cos(omega))*x+(-sin(kappa)*sin(phi)*sin(omega)+cos(kappa)*cos(omega))*y-cos(phi)*sin(omega)*z;
        difZ_k=(-cos(kappa)*sin(phi)*cos(omega)+sin(kappa)*sin(omega))*x+(sin(kappa)*sin(phi)*cos(omega)+cos(kappa)*sin(omega))*y+cos(phi)*cos(omega)*z;
        difX_omega=0;
        difY_omega=k*(cos(kappa)*sin(phi)*cos(omega)-sin(kappa)*sin(omega))*x+k*(-sin(kappa)*sin(phi)*cos(omega)-cos(kappa)*sin(omega))*y-k*cos(phi)*cos(omega)*z;
        difZ_omega=k*(cos(kappa)*sin(phi)*sin(omega)+sin(kappa)*cos(omega))*x+k*(-sin(kappa)*sin(phi)*sin(omega)+cos(kappa)*cos(omega))*y-k*cos(phi)*sin(omega)*z;
        difX_phi=-k*cos(kappa)*sin(phi)*x+k*sin(kappa)*sin(phi)*y+k*cos(phi)*z;
        difY_phi=k*cos(kappa)*cos(phi)*sin(omega)*x-k*sin(kappa)*cos(phi)*sin(omega)*y+k*sin(phi)*sin(omega)*z;
        difZ_phi=-k*cos(kappa)*cos(phi)*cos(omega)*x+k*sin(kappa)*cos(phi)*cos(omega)*y-k*sin(phi)*cos(omega)*z;
        difX_kappa=-k*sin(kappa)*cos(phi)*x-k*cos(kappa)*cos(phi)*y;
        difY_kappa=k*(-sin(kappa)*sin(phi)*sin(omega)+cos(kappa)*cos(omega))*x+k*(-cos(kappa)*sin(phi)*sin(omega)-sin(kappa)*cos(omega))*y;
        difZ_kappa=k*(sin(kappa)*sin(phi)*cos(omega)+cos(kappa)*sin(omega))*x+k*(cos(kappa)*sin(phi)*cos(omega)-sin(kappa)*sin(omega))*y;
        difX_tx=1;
        difY_tx=0;
        difZ_tx=0;
        difX_ty=0;
        difY_ty=1;
        difZ_ty=0;
        difX_tz=0;
        difY_tz=0;
        difZ_tz=1;
          
        % Design Matrix A
        A(3*i-2,1)=difX_k;
        A(3*i-2,2)=difX_omega;
        A(3*i-2,3)=difX_phi;
        A(3*i-2,4)=difX_kappa;
        A(3*i-2,5)=difX_tx;
        A(3*i-2,6)=difX_ty;
        A(3*i-2,7)=difX_tz;
        
        A(3*i-1,1)=difY_k;
        A(3*i-1,2)=difY_omega;
        A(3*i-1,3)=difY_phi;
        A(3*i-1,4)=difY_kappa;
        A(3*i-1,5)=difY_tx;
        A(3*i-1,6)=difY_ty;
        A(3*i-1,7)=difY_tz;
        
        A(3*i,1)=difZ_k;
        A(3*i,2)=difZ_omega;
        A(3*i,3)=difZ_phi;
        A(3*i,4)=difZ_kappa;
        A(3*i,5)=difZ_tx;
        A(3*i,6)=difZ_ty;
        A(3*i,7)=difZ_tz;
        
        R=R_from_angles(omega, phi, kappa);
        temp=k*R'*[x;y;z]+[tx,ty,tz]';
     
        L(3*i-2,1)=Xground(i,1)-temp(1);
        L(3*i-1,1)=Xground(i,2)-temp(2);
        L(3*i,1)=Xground(i,3)-temp(3);
        
    end
    
    % Least Squares Solution
    dX=inv(A'*A)*(A'*L);
    absol=absol+dX;
    iter=iter+1;
end

v=L-A*dX;
so=sqrt(v'*v/(3*size(model,1)-7));
VV=so^2*inv(A'*A);
