function [omega,phi,kappa]=angles_from_R(R,units)

% Returns the angles from a given Rotation Matrix of the form:
%
% 
% R=[  (cos(kappa)*cos(phi))             (cos(kappa)*sin(phi)*sin(omega)+sin(kappa)*cos(omega))            (((-cos(kappa))*sin(phi)*cos(omega))+(sin(kappa)*sin(omega)))
%     (-sin(kappa)*cos(phi))      (((-sin(kappa))*sin(phi)*sin(omega))+(cos(kappa)*cos(omega)))                   (sin(kappa)*sin(phi)*cos(omega)+cos(kappa)*sin(omega))
%                   sin(phi)                                             (-cos(phi))*sin(omega)                                                      cos(phi)*cos(omega)];
% 
% units: 0 rad (default)
%        1 grad
%        2 deg
%
%  Author: Ilias Lazaros 
%  2002


phit(1)=asin(R(3,1));
phit(2)=pi-asin(R(3,1));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

res=asin(R(3, 2) / cos(phit(1)));
omegat(1)=-res;
omegat(2)=pi+res;

res=asin(R(3, 2) / cos(phit(2)));
omegat(3)=-res;
omegat(4)=pi+res;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

res=asin(R(2, 1) / cos(phit(1)));
kappat(1)=-res;
kappat(2)=pi+res;

res=asin(R(2, 1) / cos(phit(2)));
kappat(3)=-res;
kappat(4)=pi+res;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


    
    
 angles(1, 1) = phit(1); angles(1, 2) = omegat(1); angles(1, 3) = kappat(1);
 angles(2, 1) = phit(1); angles(2, 2) = omegat(1); angles(2, 3) = kappat(2);
 angles(3, 1) = phit(1); angles(3, 2) = omegat(2); angles(3, 3) = kappat(1);
 angles(4, 1) = phit(1); angles(4, 2) = omegat(2); angles(4, 3) = kappat(2);
 angles(5, 1) = phit(2); angles(5, 2) = omegat(3); angles(5, 3) = kappat(3);
 angles(6, 1) = phit(2); angles(6, 2) = omegat(3); angles(6, 3) = kappat(4);
 angles(7, 1) = phit(2); angles(7, 2) = omegat(4); angles(7, 3) = kappat(3);
 angles(8, 1) = phit(2); angles(8, 2) = omegat(4); angles(8, 3) = kappat(4);  
    

testR(1:3,1:3)=0.00001;
 
j=0;
for i=1:8
    Rt=[(cos(angles(i,3))*cos(angles(i,1)))       (cos(angles(i,3))*sin(angles(i,1))*sin(angles(i,2))+sin(angles(i,3))*cos(angles(i,2)))               (((-cos(angles(i,3)))*sin(angles(i,1))*cos(angles(i,2)))+(sin(angles(i,3))*sin(angles(i,2))))
        (-sin(angles(i,3))*cos(angles(i,1)))      (((-sin(angles(i,3)))*sin(angles(i,1))*sin(angles(i,2)))+(cos(angles(i,3))*cos(angles(i,2))))        (sin(angles(i,3))*sin(angles(i,1))*cos(angles(i,2))+cos(angles(i,3))*sin(angles(i,2)))
        sin(angles(i,1))                          (-cos(angles(i,1)))*sin(angles(i,2))                                                                 cos(angles(i,1))*cos(angles(i,2))];
               
               if abs(Rt-R)<testR
                   j=j+1;
                   omega(j)=angles(i,2);
                   phi(j)=angles(i,1);
                   kappa(j)=angles(i,3);
                   
               end

end

if nargin==1
    units=0;
end

if units ==1
    omega=omega*200/pi;
    phi=phi*200/pi;
    kappa=kappa*200/pi;
    
elseif units == 2
    omega=omega*180/pi;
    phi=phi*180/pi;
    kappa=kappa*180/pi;
    
end