function export_DLT_results_radial(filename,im_name,control_image,P,interior,exterior,err,so,v,iter)
% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% December 2004

fid = fopen(filename,'wt');

fprintf(fid,'Matlab Photogrammetric Toolbox by PCVG\n');
fprintf(fid,'\n');
fprintf(fid,'DLT Results:\n');
fprintf(fid,'\n');
fprintf(fid,'Image: %s \n',im_name);
fprintf(fid,'\n');
fprintf(fid,'DLT Coefficients:\n');
fprintf(fid,'P1  = %f   %f \n',P(1,1),err(1));
fprintf(fid,'P2  = %f   %f \n',P(1,2),err(2));
fprintf(fid,'P3  = %f   %f \n',P(1,3),err(3));
fprintf(fid,'P4  = %f   %f \n',P(1,4),err(4));
fprintf(fid,'P5  = %f   %f \n',P(2,1),err(5));
fprintf(fid,'P6  = %f   %f \n',P(2,2),err(6));
fprintf(fid,'P7  = %f   %f \n',P(2,3),err(7));
fprintf(fid,'P8  = %f   %f \n',P(2,4),err(8));
fprintf(fid,'P9  = %f   %f \n',P(3,1),err(9));
fprintf(fid,'P10 = %f   %f \n',P(3,2),err(10));
fprintf(fid,'P11 = %f   %f \n',P(3,3),err(11));
fprintf(fid,'P12 = %f  \n',1);
fprintf(fid,'\n');
fprintf(fid,'Iterations: %d  \n',iter);
fprintf(fid,'\n');
fprintf(fid,'sigma = %f  \n',so);
fprintf(fid,'\n');
fprintf(fid,'Derived Interior Orientation:\n');
fprintf(fid,'c = %f  \n',interior(1));
fprintf(fid,'xo = %f \n',interior(2));
fprintf(fid,'yo = %f \n',interior(3));
fprintf(fid,'Computed Radial Distortion: \n');
fprintf(fid,'k1 = %e  %e \n',interior(4),err(12));
fprintf(fid,'k2 = %e  %e \n',interior(5),err(13));
fprintf(fid,'\n');
fprintf(fid,'Derived Exterior Orientation:\n');
fprintf(fid,'Xo = %f  \n',exterior(1));
fprintf(fid,'Yo = %f  \n',exterior(2));
fprintf(fid,'Zo = %f  \n',exterior(3));
fprintf(fid,'omega = %f deg  \n',exterior(4)*180/pi);
fprintf(fid,'phi = %f deg  \n',exterior(5)*180/pi);
fprintf(fid,'kappa = %f deg  \n',exterior(6)*180/pi);
fprintf(fid,'\n');
fprintf(fid,'Image Residuals:\n');
for i=1:size(v,1)/2
    fprintf(fid,'%g  %f  %f\n',control_image(i,1),v(2*i-1),v(2*i));
end
fclose(fid);