function export_absolute_results(filename,im_names,model,exterior_left,exterior_right,absol,err,so,v,iter)
% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% October 2003

fid = fopen(filename,'wt');

fprintf(fid,'Matlab Photogrammetric Toolbox by PCVG\n');
fprintf(fid,'\n');
fprintf(fid,'Absolute Orientation Results:\n');
fprintf(fid,'Image1: %s \n',im_names{1});
fprintf(fid,'Image2: %s \n',im_names{2});
fprintf(fid,'\n');
fprintf(fid,'Absolute Orientation Parameters:\n');
fprintf(fid,'k = %f   %f\n',absol(1),err(1));
fprintf(fid,'OMEGA = %f deg   %f deg\n',absol(2)*180/pi,err(2)*180/pi);
fprintf(fid,'PHI = %f deg   %f deg\n',absol(3)*180/pi,err(3)*180/pi);
fprintf(fid,'KAPPA = %f deg   %f deg\n',absol(4)*180/pi,err(4)*180/pi);
fprintf(fid,'tx = %f   %f\n',absol(5),err(5));
fprintf(fid,'ty = %f   %f \n',absol(6),err(6));
fprintf(fid,'tz = %f   %f \n',absol(7),err(7));
fprintf(fid,'\n');
fprintf(fid,'Iterations: %d  \n',iter);
fprintf(fid,'\n');
fprintf(fid,'sigma = %f  \n',so);
fprintf(fid,'\n');
fprintf(fid,'Object Space Residuals:\n');
for i=1:size(v,1)/3
    fprintf(fid,'%g  %f  %f  %f\n',model(i,1),v(3*i-2),v(3*i-1),v(3*i));
end
fprintf(fid,'\n');
fprintf(fid,'Image1 Derived Exterior Orientation:\n');
fprintf(fid,'\n');
fprintf(fid,'Xo = %f \n',exterior_left(1));
fprintf(fid,'Yo = %f   \n',exterior_left(2));
fprintf(fid,'Zo = %f   \n',exterior_left(3));
fprintf(fid,'omega = %f deg  \n',exterior_left(4)*180/pi);
fprintf(fid,'phi = %f deg  \n',exterior_left(5)*180/pi);
fprintf(fid,'kappa = %f deg  \n',exterior_left(6)*180/pi);
fprintf(fid,'\n');
fprintf(fid,'Image2 Derived Exterior Orientation:\n');
fprintf(fid,'\n');
fprintf(fid,'Xo = %f \n',exterior_right(1));
fprintf(fid,'Yo = %f   \n',exterior_right(2));
fprintf(fid,'Zo = %f   \n',exterior_right(3));
fprintf(fid,'omega = %f deg  \n',exterior_right(4)*180/pi);
fprintf(fid,'phi = %f deg  \n',exterior_right(5)*180/pi);
fprintf(fid,'kappa = %f deg  \n',exterior_right(6)*180/pi);
fclose(fid);
