function export_resection_interior_results_radial(filename,im_name,control_image,interior,exterior,err,so,v,iter)
% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% October 2003

fid = fopen(filename,'wt');

fprintf(fid,'Matlab Photogrammetric Toolbox by PCVG\n');
fprintf(fid,'\n');
fprintf(fid,'Resection with Interior Orientation Results:\n');
fprintf(fid,'\n');
fprintf(fid,'Image: %s \n',im_name);
fprintf(fid,'\n');
fprintf(fid,'Interior Orientation Parameters:\n');
fprintf(fid,'c = %f   %f\n',interior(1),err(7));
fprintf(fid,'xo = %f   %f \n',interior(2),err(8));
fprintf(fid,'yo = %f   %f \n',interior(3),err(9));
fprintf(fid,'k1 = %e   %e \n',interior(4),err(10));
fprintf(fid,'k2 = %e   %e \n',interior(5),err(11));
fprintf(fid,'\n');
fprintf(fid,'Exterior Orientation Parameters:\n');
fprintf(fid,'Xo = %f   %f\n',exterior(1),err(1));
fprintf(fid,'Yo = %f   %f \n',exterior(2),err(2));
fprintf(fid,'Zo = %f   %f \n',exterior(3),err(3));
fprintf(fid,'omega = %f deg   %f deg\n',exterior(4)*180/pi,err(4)*180/pi);
fprintf(fid,'phi = %f deg   %f deg\n',exterior(5)*180/pi,err(5)*180/pi);
fprintf(fid,'kappa = %f deg   %f deg\n',exterior(6)*180/pi,err(6)*180/pi);
fprintf(fid,'\n');
fprintf(fid,'Iterations: %d  \n',iter);
fprintf(fid,'\n');
fprintf(fid,'sigma = %f  \n',so);
fprintf(fid,'\n');
fprintf(fid,'Residuals:\n');
for i=1:size(v,1)/2
    fprintf(fid,'%g  %f  %f\n',control_image(i,1),v(2*i-1),v(2*i));
end

fclose(fid);