function [Xi,pnt_handle,button]=ginput_for_lines(flashing,point_color,number_of_points);

% flashing (optional): 0 for simple zoom
%           1 for real time zoom (may be slow for large images)
% point_color (optional): 'r+' 'b*' etc 
% number_of_points (optional)
%
% exit if ENTER pressed
% exit if ESC pressed 
% zoom extends if e or E pressed
% zoom out if RIGHT CLICK pressed     
% zoom in if SHIFT + LEFT CLICK or MIDDLE CLICK pressed
% pan if P or p pressed
% zoom window if W or w pressed
% exits if U or u or + or - pressed
% measures and plots a point if LEFT CLICK pressed

% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% December 2003

if nargin<2
    point_color='r+';
    if nargin==0
        flashing=0; 
    end
end

Xi=[];
pnt_handle=[];
button = 1;
X=0;
Y=0;
i=1;
pnt_handle=1;
set(gcf,'pointer','crosshair'); 

while ~isempty(button)           % exit if ENTER pressed
    
    [x,y,button] = ginput_cross('crosshair',1) ;      % get input from mouse or keyboard
    
    if button == 101 | button == 69  % zoom extends if e or E pressed
        axis image;
    end
    
    if button == 27         % exit if ESC pressed                      
        set(gcf,'pointer','arrow');
        return;    
    end    
    
    if button == 3         % zoom out if RIGHT CLICK pressed                        
        axout=axis;
        axis([x-(axout(2)-axout(1)) x+(axout(2)-axout(1)) y-(axout(4)-axout(3)) y+(axout(4)-axout(3))]);
    end    
    
    if button == 2 || button == 122 || button == 90         % zoom in if SHIFT + LEFT CLICK or MIDDLE CLICK pressed
        axin=axis;
        mid=[(axin(2)+axin(1))/2;
            (axin(4)+axin(3))/2];
        if flashing~=0
            xtemp=(mid(1)-x)/25;
            ytemp=(mid(2)-y)/25;
            for k=1:25
                t = timer('StartDelay',0.001,'TimerFcn','delay=1;');
                start(t);
                wait(t);
                axin=axis;
                axis([mid(1)-xtemp*k-(axin(2)-axin(1))/2.05 mid(1)-xtemp*k+(axin(2)-axin(1))/2.05 mid(2)-ytemp*k-(axin(4)-axin(3))/2.05 mid(2)-ytemp*k+(axin(4)-axin(3))/2.05]);
                k=k+1;
            end
        else
            axis([x-(axin(2)-axin(1))/4 x+(axin(2)-axin(1))/4 y-(axin(4)-axin(3))/4 y+(axin(4)-axin(3))/4]);
        end
    end
    
    if button == 112 | button==80   % pan if P or p pressed
        ax_pan=axis;
        [x_pan,y_pan] = ginput_cross('arrow',2) ;
        axis([ax_pan(1)+(x_pan(1)-x_pan(2)) ax_pan(2)+(x_pan(1)-x_pan(2)) ax_pan(3)+(y_pan(1)-y_pan(2)) ax_pan(4)+(y_pan(1)-y_pan(2))]);
    end

    if button == 119 | button==87  % zoom window if W or w pressed
        [x_win,y_win] = ginput_cross('arrow',2) ;
        axis([min(x_win) max(x_win) min(y_win) max(y_win)]);
    end
    
    
    if button==117 | button==85 | button==43 | button==45     % exits if U or u or + or - pressed
        set(gcf,'pointer','arrow');
        Xi=[X' Y'];
        return;
    end
    
    
    if button == 1      % measures and plots a point if LEFT CLICK pressed                                
        hold on
        pnt_handle(i)=plot(x,y,point_color);
        hold off
        
        X(i)=x;
        Y(i)=y;
        i=i+1;
        
        if nargin==3
            if i==number_of_points+1
                set(gcf,'pointer','arrow');
                Xi=[X' Y'];
                return;
            end
        end
        
    end
    
end 
set(gcf,'pointer','arrow');
Xi=[X' Y'];