function make_dxf_points_lines(points_3D,lines_3D,text_size)
% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% February 2005

[a b]=uiputfile({'*.dxf',  'DXF Files (*.dxf)'; '*.*',  'All Files (*.*)';},'Save DXF File');
if size(a,2)>1
    if a(end-3:end)=='.dxf'
        a(end-3:end)=[];
    end
    fid = fopen([ [b a] '.dxf'],'wt');

    fprintf(fid,'0\n');
    fprintf(fid,'SECTION\n');
    fprintf(fid,'2\n');
    fprintf(fid,'ENTITIES\n');
    fprintf(fid,'0\n');

    if ~isempty(points_3D)

        for i=1:size(points_3D,1)
            fprintf(fid,'POINT\n');
            fprintf(fid,'5\n');
            fprintf(fid,'E%i\n',points_3D(i,1));
            fprintf(fid,'8\n');
            fprintf(fid,'0\n');
            fprintf(fid,'10\n');
            fprintf(fid,'%f\n',points_3D(i,2));
            fprintf(fid,'20\n');
            fprintf(fid,'%f\n',points_3D(i,3));
            fprintf(fid,'30\n');
            fprintf(fid,'%f\n',points_3D(i,4));
            fprintf(fid,'0\n');

            fprintf(fid,'TEXT\n');
            fprintf(fid,'5\n');
            fprintf(fid,'F%i\n',points_3D(i,1));
            fprintf(fid,'8\n');
            fprintf(fid,'0\n');
            fprintf(fid,'10\n');
            fprintf(fid,'%f\n',points_3D(i,2)+0.01);
            fprintf(fid,'20\n');
            fprintf(fid,'%f\n',points_3D(i,3)+0.01);
            fprintf(fid,'30\n');
            fprintf(fid,'%f\n',points_3D(i,4));
            fprintf(fid,'40\n');
            fprintf(fid,'%f\n',text_size);
            fprintf(fid,'1\n');
            fprintf(fid,'%i\n',points_3D(i,1));
            fprintf(fid,'0\n');
        end

    end

    if ~isempty(lines_3D)

        temp1=diff(lines_3D(:,1));
        temp1(end+1)=1;
        lines_codes=lines_3D(temp1~=0 , 1);
        lines_number=size(lines_codes,1);

        for j=1:lines_number
            temp_rows=find(lines_3D(:,1)==lines_codes(j));
            one_line=lines_3D(temp_rows,:);

            fprintf(fid,'TEXT\n');
            fprintf(fid,'5\n');
            fprintf(fid,'%iF\n',j);
            fprintf(fid,'8\n');
            fprintf(fid,'0\n');
            fprintf(fid,'10\n');
            fprintf(fid,'%f\n',one_line(1,3)+0.01);
            fprintf(fid,'20\n');
            fprintf(fid,'%f\n',one_line(1,4)+0.01);
            fprintf(fid,'30\n');
            fprintf(fid,'%f\n',one_line(1,5));
            fprintf(fid,'40\n');
            fprintf(fid,'%f\n',text_size);
            fprintf(fid,'1\n');
            fprintf(fid,'%i\n',lines_codes(j));
            fprintf(fid,'0\n');

            for i=1:size(one_line,1)-1
                fprintf(fid,'LINE\n');
                fprintf(fid,'5\n');
                fprintf(fid,'D%i%i\n',j,i);
                fprintf(fid,'8\n');
                fprintf(fid,'0\n');
                fprintf(fid,'10\n');
                fprintf(fid,'%f\n',one_line(i,3));
                fprintf(fid,'20\n');
                fprintf(fid,'%f\n',one_line(i,4));
                fprintf(fid,'30\n');
                fprintf(fid,'%f\n',one_line(i,5));
                fprintf(fid,'11\n');
                fprintf(fid,'%f\n',one_line(i+1,3));
                fprintf(fid,'21\n');
                fprintf(fid,'%f\n',one_line(i+1,4));
                fprintf(fid,'31\n');
                fprintf(fid,'%f\n',one_line(i+1,5));
                fprintf(fid,'0\n');
            end
        end

    end

    fprintf(fid,'ENDSEC\n');
    fprintf(fid,'0\n');
    fprintf(fid,'EOF\n');
    fclose(fid);
end
