function lines_matrix=measure_lines(line_code,line_id,image_number,lines_matrix,flashing,im)

% lines_matrix=[image_number    line_id    line_code    pnt_code   line_handle(text_handle for first point)   pnt_handle    x(pixels)    y(pixels)]

% line_id:  10   Vectorisation
% line_id:  12   Vectorisation (for 2D Projective)

% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% December 2003


point_color={'b+' 'r+' 'g+' 'c+' 'r+' 'r+' 'r+' 'r+' 'b+' 'k+' 'k+' 'k+'}; 
line_color={'b' 'r' 'g' 'c' 'r' 'r' 'r' 'r' 'b' 'k' 'k' 'k'}; 
winx=1;
pnt_code=0;
undo=0;

if   ~isempty(lines_matrix) 
    temp=find(lines_matrix(:,3)==line_code & lines_matrix(:,1)==image_number & lines_matrix(:,2)==line_id); % Find the line of points_matrix if point is already measured
    if temp
        button = questdlg('The line already exists.Do you want to add points?','Line Duplicated','Yes','No','No');
        if strcmp(button,'Yes')
            % find the code of the last point of the line 
            pnt_code=max(lines_matrix(find(lines_matrix(:,1)==image_number & lines_matrix(:,2)==line_id & lines_matrix(:,3)==line_code),4));
            xy_old=lines_matrix(find(lines_matrix(:,1)==image_number & lines_matrix(:,2)==line_id & lines_matrix(:,3)==line_code & lines_matrix(:,4)==pnt_code),7:8);
        else 
            return;
        end
    end
end


figure(image_number);
button=1;
while 1~=2
    
    [xy,pnt_handle,button]=ginput_for_lines(flashing,point_color{line_id},1);
    
    if button == 1      % measures and plots a point if LEFT CLICK pressed    
        pnt_code=pnt_code+1;
        undo=undo+1;
        
        if winx>1
            [xy,good,bad,type] = cornerfinder(xy',im,winx,winx);
            xy=xy';
            hold on;
            delete(pnt_handle);
            pnt_handle=plot(xy(1),xy(2),point_color{line_id});
        end
        
        if pnt_code==1
            line_handle=text(xy(1)+9,xy(2)-9,num2str(line_code),'Color',line_color{line_id},'FontSize',8);
        else
            line_handle=line([xy_old(1) xy(1)],[xy_old(2) xy(2)],'Color',line_color{line_id},'LineWidth',.4);
        end
        
        lines_matrix=[lines_matrix; image_number line_id line_code pnt_code line_handle pnt_handle xy(1) xy(2)];
        xy_old=xy;
    end
    
    if button==43     % increase Harris operator window if + pressed
        winx=winx+2;
        title(['Harris operator window size: ' num2str(winx)]);
    end
    
    if button==45       % decrease Harris operator window if - pressed
        winx=winx-2;
        title(['Harris operator window size: ' num2str(winx)]);
    end
    
    if button==117 | button==85  % delete last point and line segment if U or u pressed
        if undo>0
            delete(lines_matrix(end,5));
            delete(lines_matrix(end,6));
            lines_matrix(end,:)=[];
            undo=undo-1;
            pnt_code=pnt_code-1;
            xy_old=lines_matrix(end,7:8);
        end
    end    
    
    if button == 27       % exit if ESC pressed                      
        set(gcf,'pointer','arrow');
        title('');
        return;    
    end
    
    if  isempty(button)      % exit if ENTER pressed                      
        set(gcf,'pointer','arrow');
        title('');
        return;    
    end
      
end