function points_matrix=measure_points(pnt_code,pnt_id,image_number,points_matrix,flashing,image_size)
% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% November 2003
% points_matrix=[image_number  pnt_code    pnt_id   pnt_handle   text_handle    x(pixels)    y(pixels) enable/disable(1/0)]
% pnt_id:  1  tie
%          2  X Y Z
%          3  X Y
%          4  Z
%          5  X
%          6  Y
%          7  X Z
%          8  Y Z
%          9  Fiducial
%          10 Vectorisation
%          11 X Y (for 2D Projective)
%          12 Vectorisation (for 2D Projective)
% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% December 2003


point_color={'g+' 'r+' 'r+' 'r+' 'r+' 'r+' 'r+' 'r+' 'b+' 'k+' 'm+' 'k+'}; 
duplicate=0;

if   ~isempty(points_matrix) 
    temp=find(points_matrix(:,2)==pnt_code & points_matrix(:,1)==image_number & points_matrix(:,3)==pnt_id); % Find the line of points_matrix if point is already measured
    if temp
        button = questdlg('The point already exists.Do you want to repeat the measurement?','Point Duplicated','Yes','No','No');
        if strcmp(button,'Yes')
            duplicate=1;
            figure(image_number);
            axin=axis;
            x=points_matrix(temp,6);
            y=points_matrix(temp,7);
            axis([x-image_size(1)/20 x+image_size(1)/20 y-image_size(1)/20 y+image_size(1)/20]);
        else 
            return;
        end
    end
end

figure(image_number);
[xy,pnt_handle,button]=ginput_full(flashing,point_color{pnt_id},1);

if ~isempty(xy)
    text_color=point_color{pnt_id};
    text_color=text_color(1);
    text_handle=text(xy(1)+9,xy(2)-9,num2str(pnt_code),'Color',text_color,'FontSize',8);
    
    if duplicate==0        
        points_matrix=[points_matrix; image_number pnt_code pnt_id pnt_handle text_handle xy(1) xy(2) 1];
    else
        delete(points_matrix(temp,4));
        delete(points_matrix(temp,5));
        points_matrix(temp,4)=pnt_handle;
        points_matrix(temp,5)=text_handle;
        points_matrix(temp,6)=xy(1);
        points_matrix(temp,7)=xy(2);
    end
    
end
