function [XYZ,iter]=multiple_intersection2(points_info,interior,exterior,cpX,cpY,cpZ,limit,maxiter)
         [XYZ,so,VV,v,iter]=intersection(exterior_1,exterior_2,interior,x1,y1,x2,y2,limit,maxiter)
% exterior=[Xo Yo Zo omega phi kappa]
% interior=[c1,xo1,yo1 ; c2,xo2,yo2]
% limit=[linear ] convergence limit ie:[0.001(m)]
% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% October 2003
% November 2004 different interiors 




R1=R_from_angles(exterior_1(4),exterior_1(5),exterior_1(6),0)';
c1=interior(1,1);
xo1=interior(1,2);
yo1=interior(1,3);
X01=exterior_1(1);
Y01=exterior_1(2);
Z01=exterior_1(3);

R2=R_from_angles(exterior_2(4),exterior_2(5),exterior_2(6),0)';
c2=interior(2,1);
xo2=interior(2,2);
yo2=interior(2,3);
X02=exterior_2(1);
Y02=exterior_2(2);
Z02=exterior_2(3);


% Find initial values
ZX1=R1(1,1)*(x1-xo1)+R1(1,2)*(y1-yo1)-R1(1,3)*c1;
ZY1=R1(2,1)*(x1-xo1)+R1(2,2)*(y1-yo1)-R1(2,3)*c1;
n1=R1(3,1)*(x1-xo1)+R1(3,2)*(y1-yo1)-R1(3,3)*c1;

ZX2=R2(1,1)*(x2-xo2)+R2(1,2)*(y2-yo2)-R2(1,3)*c2;
ZY2=R2(2,1)*(x2-xo2)+R2(2,2)*(y2-yo2)-R2(2,3)*c2;
n2=R2(3,1)*(x2-xo2)+R2(3,2)*(y2-yo2)-R2(3,3)*c2;

if abs(X01-X02)>abs(Y01-Y02)
    XYZ(1,3)=(X02-(Z02*(ZX2/n2))+(Z01*(ZX1/n1))-X01)/((ZX1/n1)-(ZX2/n2));
    XYZ(1,1)=X01+(XYZ(1,3)-Z01)*(ZX1/n1);
    XYZ(1,2)=Y01+(XYZ(1,3)-Z01)*(ZY1/n1);
else
    XYZ(1,3)=(Y02-(Z02*(ZY2/n2))+(Z01*(ZY1/n1))-Y01)/((ZY1/n1)-(ZY2/n2));
    XYZ(1,1)=X01+(XYZ(1,3)-Z01)*(ZX1/n1);
    XYZ(1,2)=Y01+(XYZ(1,3)-Z01)*(ZY1/n1);
end

X=XYZ(1,1);Y=XYZ(1,2);Z=XYZ(1,3);

iter=0;

% To enter the first loop
dX=1+limit; 

while max(abs(dX))>=limit   
    if iter>=maxiter-1 
        break
    end
    for i=1:size(points_info,1)
        
        x = points_info(i, 4);
        y = points_info(i, 5);
        
        Xo=exterior(1,points_info(i,1));
        Yo=exterior(2,points_info(i,1));
        Zo=exterior(3,points_info(i,1));
        omega=exterior(4,points_info(i,1));
        phi=exterior(5,points_info(i,1));
        kappa=exterior(6,points_info(i,1));
        
        c=interior(1,points_info(i,6));
        xo=interior(2,points_info(i,6));
        yo=interior(3,points_info(i,6));
        
        difx_X=-c*cos(kappa)*cos(phi)/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))+c*(cos(kappa)*cos(phi)*(X-Xo)+(cos(kappa)*sin(phi)*sin(omega)+sin(kappa)*cos(omega))*(Y-Yo)+(-cos(kappa)*sin(phi)*cos(omega)+sin(kappa)*sin(omega))*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))^2*sin(phi);
        dify_X=c*sin(kappa)*cos(phi)/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))+c*(-sin(kappa)*cos(phi)*(X-Xo)+(-sin(kappa)*sin(phi)*sin(omega)+cos(kappa)*cos(omega))*(Y-Yo)+(sin(kappa)*sin(phi)*cos(omega)+cos(kappa)*sin(omega))*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))^2*sin(phi);
        difx_Y=-c*(cos(kappa)*sin(phi)*sin(omega)+sin(kappa)*cos(omega))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))-c*(cos(kappa)*cos(phi)*(X-Xo)+(cos(kappa)*sin(phi)*sin(omega)+sin(kappa)*cos(omega))*(Y-Yo)+(-cos(kappa)*sin(phi)*cos(omega)+sin(kappa)*sin(omega))*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))^2*cos(phi)*sin(omega);
        dify_Y=-c*(-sin(kappa)*sin(phi)*sin(omega)+cos(kappa)*cos(omega))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))-c*(-sin(kappa)*cos(phi)*(X-Xo)+(-sin(kappa)*sin(phi)*sin(omega)+cos(kappa)*cos(omega))*(Y-Yo)+(sin(kappa)*sin(phi)*cos(omega)+cos(kappa)*sin(omega))*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))^2*cos(phi)*sin(omega);
        difx_Z=-c*(-cos(kappa)*sin(phi)*cos(omega)+sin(kappa)*sin(omega))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))+c*(cos(kappa)*cos(phi)*(X-Xo)+(cos(kappa)*sin(phi)*sin(omega)+sin(kappa)*cos(omega))*(Y-Yo)+(-cos(kappa)*sin(phi)*cos(omega)+sin(kappa)*sin(omega))*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))^2*cos(phi)*cos(omega);
        dify_Z=-c*(sin(kappa)*sin(phi)*cos(omega)+cos(kappa)*sin(omega))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))+c*(-sin(kappa)*cos(phi)*(X-Xo)+(-sin(kappa)*sin(phi)*sin(omega)+cos(kappa)*cos(omega))*(Y-Yo)+(sin(kappa)*sin(phi)*cos(omega)+cos(kappa)*sin(omega))*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))^2*cos(phi)*cos(omega);
        
        A(2*i-1,1)=difx_X;
        A(2*i-1,2)=difx_Y;
        A(2*i-1,3)=difx_Z;
        A(2*i,1)=dify_X;
        A(2*i,2)=dify_Y;
        A(2*i,3)=dify_Z;
        
        [tempx,tempy]=colinearity(c,xo,yo,Xo,Yo,Zo,omega,phi,kappa,X,Y,Z);
        L(2*i-1,1)=x-tempx;
        L(2*i,1)=y-tempy;
        
    end
    
    % Least Squares Solution
    dX=inv(A'*A)*(A'*L);
    X=X+dX(1);
    Y=Y+dX(2);
    Z=Z+dX(3);
    iter=iter+1;
    
end

% Telikes times
XYZ(1,1)=X;
XYZ(1,2)=Y;
XYZ(1,3)=Z;
