% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% November 2004


function varargout = pcvg(varargin)

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @pcvg_OpeningFcn, ...
    'gui_OutputFcn',  @pcvg_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function pcvg_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;

guidata(hObject, handles);

set(handles.save,'Enable','off');
handles.im_names={};
handles.points_matrix=[];
handles.images_size=[];
handles.images_size_affine=[];
handles.lines_matrix=[];
handles.fiducial_image=[];
handles.affine_results=[];
handles.interior=[];
handles.control_ground=[];
handles.exterior_initial=[];
handles.exterior=[];
handles.pnt_id=[];
handles.line_id=[];
handles.stereo_pair=[1 2];
handles.export_option=1;
handles.relative_initial=[0 0 0 0 0 0 0];
handles.relative_results=[0 0 0 0 0 0 0];
handles.absolute_initial=[0 0 0 0 0 0 0 0 0];
handles.absolute_results=[0 0 0 0 0 0 0 0 0];
handles.P_all=[];
handles.H_all=[];
handles.text_size=0.3;
handles.photogrammetric_switch=1;
handles.images_exist=1;
guidata(hObject,handles);

warning off Images:initSize:adjustingMag;
warning off MATLAB:nearlySingularMatrix;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function varargout = pcvg_OutputFcn(hObject, eventdata, handles)

varargout{1} = handles.output;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function image_list_CreateFcn(hObject, eventdata, handles)

if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function editbox_point_code_CreateFcn(hObject, eventdata, handles)

if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function editbox_vp_CreateFcn(hObject, eventdata, handles)

if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end










%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      BUTTONS ETC    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function image_list_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

pnt_id=handles.pnt_id;
current_figure=get(handles_inner.image_list,'Value');
handles.current_figure=current_figure;
images_exist=handles.images_exist;

if images_exist
    file_name=get(handles_inner.image_list,'String');
    file_name=char(file_name(current_figure));
    points_matrix=handles.points_matrix;
    lines_matrix=handles.lines_matrix;
    im_names=handles.im_names;


    if ~isempty(points_matrix)
        pnt_code=max(points_matrix(find(points_matrix(:,3)==pnt_id & points_matrix(:,1)==current_figure),2));
        set(handles_inner.editbox_point_code,'String',num2str(pnt_code+1));
    end

    if figflag(file_name,0)
        figure(current_figure);
    else
        figure(current_figure);

        image=imread(im_names{current_figure});
        imshow(image);
        set(current_figure,'Name',file_name,'NumberTitle','off','Toolbar','none','Menubar','none','Position',[500 100 500 500]);
        if ~isempty(points_matrix)
            points_matrix=plot_points_matrix(points_matrix,current_figure);
            handles.points_matrix=points_matrix;
        end
        if ~isempty(lines_matrix)
            lines_matrix=plot_lines_matrix(lines_matrix,current_figure);
            handles.lines_matrix=lines_matrix;
        end
    end
    set(handles_inner.figure1,'Visible','on');
end


guidata(hObject,handles);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function editbox_vp_Callback(hObject, eventdata, handles)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function editbox_point_code_Callback(hObject, eventdata, handles)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function btn_measure_point_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

current_figure=handles.current_figure;
pnt_code=str2num(get(handles_inner.editbox_point_code,'String'));
points_matrix=handles.points_matrix;
images_size=handles.images_size;
pnt_id=handles.pnt_id;

if ~isempty(pnt_code)
    points_matrix=measure_points(pnt_code,pnt_id,current_figure,points_matrix,0,images_size(current_figure,:));
    % points_matrix=measure_points(pnt_code,pnt_id,image_number,points_matrix,flashing,image_size)
    handles.points_matrix=points_matrix;
    set(handles_inner.figure1,'Visible','on');
    set(handles_inner.editbox_point_code,'String',num2str(pnt_code+1));
end

guidata(hObject,handles);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function btn_delete_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

option_measure=handles.option_measure;
current_figure=handles.current_figure;
pnt_line_code=str2num(get(handles_inner.editbox_point_code,'String'));
figure(current_figure);
pnt_id=handles.pnt_id;
line_id=handles.line_id;

switch option_measure
    case 1 % Points
        points_matrix=handles.points_matrix;

        if ~isempty(points_matrix) && ~isempty(pnt_line_code)
            temp=find(points_matrix(:,2)==pnt_line_code & points_matrix(:,1)==current_figure & ...
                points_matrix(:,3)==pnt_id); % Find the line of points_matrix if point is already measured
            delete(points_matrix(temp,4));
            delete(points_matrix(temp,5));
            points_matrix(temp,:)=[];
            handles.points_matrix=points_matrix;
        end

    case 2  %Lines

        lines_matrix=handles.lines_matrix;

        if ~isempty(lines_matrix) && ~isempty(pnt_line_code)
            temp=find(lines_matrix(:,3)==pnt_line_code & lines_matrix(:,2)==line_id ...
                & lines_matrix(:,1)==current_figure); % Find the line of points_matrix if point is already measured
            delete(lines_matrix(temp,5));
            delete(lines_matrix(temp,6));
            lines_matrix(temp,:)=[];
            handles.lines_matrix=lines_matrix;
        end

end
set(handles_inner.figure1,'Visible','on');

guidata(hObject,handles);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function btn_measure_line_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

current_figure=handles.current_figure;
line_code=str2num(get(handles_inner.editbox_point_code,'String'));
lines_matrix=handles.lines_matrix;
line_id=handles.line_id;
im_names=handles.im_names;

if ~isempty(line_code) && ~isempty(line_id)
    im=imread(im_names{current_figure});
    lines_matrix=measure_lines(line_code,line_id,current_figure,lines_matrix,0,im);
    % points_matrix=measure_points(pnt_code,pnt_id,image_number,points_matrix,flashing,image_size)
    handles.lines_matrix=lines_matrix;
    set(handles_inner.figure1,'Visible','on');
    set(handles_inner.editbox_point_code,'String',num2str(line_code+1));
end

guidata(hObject,handles);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function btn_end_of_measurements_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

set(handles_inner.btn_measure_line,'Enable','off');
set(handles_inner.btn_measure_point,'Visible','on','Enable','off');
set(handles_inner.editbox_vp,'Visible','off');
set(handles_inner.btn_delete,'Enable','off');
set(handles_inner.btn_end_of_measurements,'Enable','off');
set(handles_inner.editbox_point_code,'Enable','off');
set(handles_inner.editbox_point_code,'String','');
set(handles_inner.txt_id,'String','');
handles.pnt_id=15;

guidata(hObject,handles);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      FILE    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function file_Callback(hObject, eventdata, handles)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function open_project_Callback(hObject, eventdata, handles)

handles_inner = guihandles;

[file_name file_path]=uigetfile({'*.mat',  'Project Files (*.mat)'; '*.*',  'All Files (*.*)';},'Save Project');
if file_name~=0

    load([file_path file_name]);

    handles.project_file=[file_path file_name];
    handles.project_path=file_path;
    cd(file_path);
    set(handles_inner.save,'Enable','On');
    set(handles_inner.txt,'String','Project Opened' );
    set(handles_inner.txt_project,'String',['Current Project: ' file_name]);
    im_names=handles.im_names;
    set(handles_inner.image_list,'Enable','on');
    number_of_images=size(im_names,2);
    set(handles_inner.image_list,'String',im_names);
    points_matrix=handles.points_matrix;
    lines_matrix=handles.lines_matrix;
    images_exist=handles.images_exist;

    if images_exist
        for i=1:number_of_images
            figure(i);

            im=imread(im_names{i});
            imshow(im);
            set(i,'Name',im_names{i},'NumberTitle','off','Toolbar','none','Menubar','none','Position',[500 100 500 500]);
            if ~isempty(points_matrix)
                figure(i);
                points_matrix=plot_points_matrix(points_matrix,i);
            end
            if ~isempty(lines_matrix)
                %             figure(i);
                lines_matrix=plot_lines_matrix(lines_matrix,i);
            end

        end
        % figure(1);
        handles.points_matrix=points_matrix;
        handles.lines_matrix=lines_matrix;
    end
    set(handles_inner.open_project,'Enable','off');
    handles.current_figure=1;
    set(handles_inner.figure1,'Visible','on');
end

guidata(hObject,handles);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function save_as_Callback(hObject, eventdata, handles)

handles_inner = guihandles;

[file_name file_path]=uiputfile({'*.mat',  'Project Files (*.mat)'; '*.*',  'All Files (*.*)';},'Save Project');

if file_name~=0
    if file_name(end-3:end)=='.mat'
        file_name(end-3:end)=[];
    end
    handles.project_file=[file_path file_name];
    save([file_path file_name], 'handles');
    handles.project_path=file_path;
    cd(file_path);
    mkdir([file_path 'results\']);
    set(handles_inner.save,'Enable','On');
    set(handles_inner.txt,'String','Project Saved' );
    set(handles_inner.txt_project,'String',['Current Project: ' file_name]);
    set(handles_inner.open_project,'Enable','off');
end

guidata(hObject,handles);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function save_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

project_file=handles.project_file;
save(project_file, 'handles');
set(handles_inner.txt,'String','Project Saved' );

guidata(hObject,handles);

% --------------------------------------------------------------------
function export_point_matrix_Callback(hObject, eventdata, handles)

points_matrix=handles.points_matrix;
affine_results=handles.affine_results;
project_path=handles.project_path;
interior=handles.interior;
points_matrix_affine=tranform_measured_points(affine_results,points_matrix,interior);
points_matrix_affine=sortrows(points_matrix_affine,2);
points_matrix_affine=sortrows(points_matrix_affine,1);

filename=[project_path 'results\point_matrix_affine.txt'];
dlmwrite(filename,points_matrix_affine,'delimiter',',','newline','pc', 'precision', '%f');

guidata(hObject,handles);

% --------------------------------------------------------------------
function import_point_matrix_Callback(hObject, eventdata, handles)
% import file points_matrix=[image_num point_num point_id x y]
handles_inner = guihandles;

[a b]=uigetfile({'*.txt',  'Text Files (*.txt)'; '*.*',  'All Files (*.*)';},'Select points matrix file');

if size(a,2)>1
    points_matrix_temp=load([b a]);
    points_matrix_temp=sortrows(points_matrix_temp,[1 2 3]);
    handles.points_matrix=points_matrix_temp;
    % Create a matrix having each image number once
    images_temp=[points_matrix_temp(find((diff(points_matrix_temp(:,1)'))==1),1); points_matrix_temp(end,1)]; 
    set(handles_inner.image_list,'Enable','on');
    im_names=handles.im_names;
    affine_results=handles.affine_results;
    interior=handles.interior;
    for i=1:size(images_temp,1)
        im_names(end+1)={['Image_' num2str(i) '    ']};
        set(handles_inner.image_list,'String',im_names);
        number_of_images=size(im_names,2);
        set(handles_inner.image_list,'Value',number_of_images);
        affine_results(number_of_images,:)=[1 0 0 0 1 0];
        interior(number_of_images,:)=[0 0 0 0 0];
    end
    handles.interior=interior;
    handles.current_figure=i;
    handles.im_names=im_names;
    handles.affine_results=affine_results;
    points_matrix=points_matrix_temp(:,1:3);
    points_matrix(:,6:7)=points_matrix_temp(:,4:5);
    points_matrix(:,8)=1;
    handles.points_matrix=points_matrix;
    handles.images_exist=0;
    set(handles_inner.txt,'String','Points matrix loaded successfully' );
end

guidata(hObject,handles);

% --------------------------------------------------------------------
function add_images_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

im_names=handles.im_names;
number_of_images=size(im_names,2);

if number_of_images==2  % prevent opening a third image
    return;
end

[file_name file_path]=uigetfile({'*.jpg;*.tif;*.bmp',  'Image Files (*.jpg,*.tif,*.bmp)'; '*.*',  'All Files (*.*)';},'Select Image');

if file_name~=0   % check if cancel is pressed

    images_size=handles.images_size;

    if find(strcmp(im_names,file_name))
        warndlg([file_name ' already exists!'],'Warning');
        return;
    else
        handles.project_path=file_path;
        cd(file_path);
        set(handles_inner.image_list,'Enable','on');
        im_names(end+1)={file_name};
        set(handles_inner.image_list,'String',im_names);
        number_of_images=size(im_names,2);
        set(handles_inner.image_list,'Value',number_of_images);
        figure(number_of_images);
        
        im=imread([file_path file_name]);
        imshow(im);
        set(number_of_images,'Name',file_name,'NumberTitle','off','Toolbar','none','Menubar','none','Position',[500 100 500 500]);
        images_size=[images_size; size(im,1) size(im,2)];
        images_size_affine=images_size;

        affine_results=handles.affine_results;
        affine_results(number_of_images,:)=[1 0 0 0 1 0];
        handles.affine_results=affine_results;

        interior=handles.interior;
        interior(number_of_images,:)=[0 size(im,2)/2 size(im,1)/2 0 0];
        handles.interior=interior;
    end
    handles.im_names=im_names;
    handles.images_size=images_size;
    handles.images_size_affine=images_size_affine;
    handles.current_figure=number_of_images;
    set(handles_inner.figure1,'Visible','on');
    set(handles_inner.open_project,'Enable','off');
end

guidata(hObject,handles);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      INTERIOR   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --------------------------------------------------------------------
function Interior_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function Enter_Interior_Orientation_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

current_figure=handles.current_figure;
interior=handles.interior;
prompt = {'c ','xo ','yo ','k1 ','k2 '};
dlg_title = 'Interior Orientation';
num_lines= 1;

if size(interior,1)>=current_figure
    def     = {num2str(interior(current_figure,1)),num2str(interior(current_figure,2)),num2str(interior(current_figure,3)),num2str(interior(current_figure,4)),num2str(interior(current_figure,5))};
    answer  = inputdlg(prompt,dlg_title,num_lines,def);
else
    def     = {'','','','0','0'};
    answer  = inputdlg(prompt,dlg_title,num_lines,def);
end

if length(answer)
    if ~isnan(str2double(answer))
        interior(current_figure,1)=str2double(answer{1});
        interior(current_figure,2)=str2double(answer{2});
        interior(current_figure,3)=str2double(answer{3});
        interior(current_figure,4)=str2double(answer{4});
        interior(current_figure,5)=str2double(answer{5});
        handles.interior=interior;
        set(handles_inner.txt,'String','Interior orientation parameters entered successfully' );
    end
end

guidata(hObject,handles);

% --------------------------------------------------------------------
function Analogue_Camera_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function Measure_Fiducials_Callback(hObject, eventdata, handles)

measure_points_pref(9,handles,hObject);

% --------------------------------------------------------------------
function Import_Fiducial_Known_Coordinates_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

[a b]=uigetfile({'*.txt',  'Text Files (*.txt)'; '*.*',  'All Files (*.*)';},'Select fiducials known-coordinates file');

if size(a,2)>1
    current_figure=handles.current_figure;
    fiducial_image=handles.fiducial_image;
    if ~isempty(fiducial_image)
        fiducial_image(fiducial_image(:,1)==current_figure,:)=[];
    end
    fiducial_image_temp=load([b a]);
    fiducial_image_temp=sortrows(fiducial_image_temp,1);
    fiducial_image_temp=[ones(size(fiducial_image_temp,1),1)*current_figure fiducial_image_temp];
    fiducial_image=[fiducial_image; fiducial_image_temp];
    handles.fiducial_image=fiducial_image;
    set(handles_inner.txt,'String','Fiducials known-coordinates loaded successfully' );
end

guidata(hObject,handles);

% --------------------------------------------------------------------
function Compute_Affine_Parameters_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

current_figure=handles.current_figure;
fiducial_image=handles.fiducial_image;
points_matrix=handles.points_matrix;
affine_results=handles.affine_results;
im_names=handles.im_names;
project_path=handles.project_path;
export_option=handles.export_option;

fiducial_image_temp=fiducial_image(fiducial_image(:,1)==current_figure,2:end);
fiducial_pixel_temp=points_matrix(points_matrix(:,1)==current_figure & ...
    points_matrix(:,3)==9 & points_matrix(:,8)==1 ,[2,6,7]);

fiducial_image=find_common(fiducial_image_temp,fiducial_pixel_temp);
fiducial_pixel=find_common(fiducial_pixel_temp,fiducial_image_temp);

[affine_results_temp,so,VV,v]=mpt_affine(fiducial_pixel(:,2:3),fiducial_image(:,2:3));
err=sqrt(diag(VV));
set(handles_inner.txt,'String','Affine parameters computed successfully' );
affine_results(current_figure,:)=affine_results_temp';
handles.affine_results=affine_results;
show_affine_results(im_names{current_figure},fiducial_image,affine_results_temp,err,so,v);
if export_option
    filename=[project_path 'results\' im_names{current_figure}(1:end-4) '_affine.txt'];
    export_affine_results(filename,im_names{current_figure},fiducial_image,affine_results_temp,err,so,v);
end

guidata(hObject,handles);

% --------------------------------------------------------------------
function Compute_Affine_Digital_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

current_figure=handles.current_figure;
affine_results=handles.affine_results;
images_size=handles.images_size;
images_size_affine=handles.images_size_affine;

prompt = {'Width','Height',};
dlg_title = 'Image Dimensions';
num_lines= 1;
def     = {num2str(images_size_affine(current_figure,2)),num2str(images_size_affine(current_figure,1))};
answer  = inputdlg(prompt,dlg_title,num_lines,def);

if length(answer)
    if ~isnan(str2double(answer))
        im_width=str2double(answer{1});
        im_height=str2double(answer{2});
        images_size_affine(current_figure,2)=im_width;
        images_size_affine(current_figure,1)=im_height;
        scale=(im_width/images_size(current_figure,2)+im_height/images_size(current_figure,1))/2;
        affine_results(current_figure,1)=scale;
        affine_results(current_figure,2)=0;
        affine_results(current_figure,3)=-scale*images_size(current_figure,2)/2;
        affine_results(current_figure,4)=0;
        affine_results(current_figure,5)=-scale;
        affine_results(current_figure,6)=scale*images_size(current_figure,1)/2;
    end
end

set(handles_inner.txt,'String','Affine parameters computed successfully' );
handles.affine_results=affine_results;
handles.images_size_affine=images_size_affine;

guidata(hObject,handles);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      RESECTION  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --------------------------------------------------------------------
function Resection_Callback(hObject, eventdata, handles)

% --------------------------------------------------------------------
function Measure_Control_Points_Callback(hObject, eventdata, handles)

measure_points_pref(2,handles,hObject);

% --------------------------------------------------------------------
function Import_Ground_Coordinates_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

[a b]=uigetfile({'*.txt',  'Text Files (*.txt)'; '*.*',  'All Files (*.*)';},'Select file of control-points in ground-coordinates');

if size(a,2)>1
    current_figure=handles.current_figure;
    control_ground=load([b a]);
    control_ground=sortrows(control_ground,1);
    handles.control_ground=control_ground;
    set(handles_inner.txt,'String','Ground-coordinates loaded successfully' );
end

guidata(hObject,handles);

% --------------------------------------------------------------------
function Enter_Initial_Values_Resection_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

current_figure=handles.current_figure;
exterior_initial=handles.exterior_initial;
prompt = {'Xo','Yo ','Zo ','Omega (deg)','Phi (deg)','Kappa (deg)'};
dlg_title = 'Initial Values of Exterior Orientation';
num_lines= 1;

if size(exterior_initial,1)>=current_figure
    def     = {num2str(exterior_initial(current_figure,1)),num2str(exterior_initial(current_figure,2)),num2str(exterior_initial(current_figure,3)),num2str(exterior_initial(current_figure,4)*180/pi),num2str(exterior_initial(current_figure,5)*180/pi),num2str(exterior_initial(current_figure,6)*180/pi)};
    answer  = inputdlg(prompt,dlg_title,num_lines,def);
else
    answer  = inputdlg(prompt,dlg_title,num_lines);
end

if length(answer)
    if ~isnan(str2double(answer))
        exterior_initial(current_figure,1)=str2double(answer{1});
        exterior_initial(current_figure,2)=str2double(answer{2});
        exterior_initial(current_figure,3)=str2double(answer{3});
        exterior_initial(current_figure,4)=str2double(answer{4});
        exterior_initial(current_figure,5)=str2double(answer{5});
        exterior_initial(current_figure,6)=str2double(answer{6});
        exterior_initial(current_figure,4:6)=exterior_initial(current_figure,4:6)*pi/180;
        handles.exterior_initial=exterior_initial;
        set(handles_inner.txt,'String','Initial values of exterior orientation entered successfully' );
    end
end

guidata(hObject,handles);

% --------------------------------------------------------------------
function Compute_Exterior_Orientation_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

prompt = {'Linear ','Angular (deg)','Maximum Iterations'};
dlg_title = 'Convergence Limit';
num_lines= 1;
def     = {num2str(0.0001),num2str(0.0001),num2str(20)};
answer  = inputdlg(prompt,dlg_title,num_lines,def);

if length(answer)
    if ~isnan(str2double(answer))

        limit(1)=str2double(answer{1});
        limit(2)=str2double(answer{2})*pi/180;
        maxiter=str2double(answer{3});

        current_figure=handles.current_figure;
        exterior_initial=handles.exterior_initial;
        points_matrix=handles.points_matrix;
        affine_results=handles.affine_results;
        im_names=handles.im_names;
        exterior_initial=handles.exterior_initial;
        control_ground_temp=handles.control_ground;
        interior=handles.interior;
        exterior=handles.exterior;
        project_path=handles.project_path;
        export_option=handles.export_option;

        points_matrix_affine=tranform_measured_points(affine_results,points_matrix,interior);

        control_image_temp=points_matrix_affine(points_matrix_affine(:,1)==current_figure & points_matrix_affine(:,3)==2 & points_matrix_affine(:,6)==1,[2,4,5]);

        control_ground=find_common(control_ground_temp,control_image_temp);
        control_image=find_common(control_image_temp,control_ground_temp);

        [exterior_temp,so,VV,v,iter]=resection(exterior_initial(current_figure,:),interior(current_figure,:)...
            ,control_image(:,2:3),control_ground(:,2:4),limit,maxiter);
        err=sqrt(diag(VV));

        exterior(current_figure,:)=exterior_temp';
        set(handles_inner.txt,'String','Exterior orientation computed successfully' );
        handles.exterior=exterior;

        show_resection_results(im_names{current_figure},control_image,exterior_temp,err,so,v,iter);
        if export_option
            filename=[project_path 'results\' im_names{current_figure}(1:end-4) '_resection.txt'];
            export_resection_results(filename,im_names{current_figure},control_image,exterior_temp,err,so,v,iter);
        end

    end
end

guidata(hObject,handles);

% --------------------------------------------------------------------
function Compute_Exterior_and_Interior_Orientation_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function Compute_Exterior_and_Interior_Orientation_no_radial_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

prompt = {'Linear ','Angular (deg)','Linear for Interior ','Maximum Iterations'};
dlg_title = 'Convergence Limit';
num_lines= 1;
def     = {num2str(0.0001),num2str(0.0001),num2str(0.001),num2str(20)};
answer  = inputdlg(prompt,dlg_title,num_lines,def);

if length(answer)
    if ~isnan(str2double(answer))

        limit(1)=str2double(answer{1});
        limit(2)=str2double(answer{2})*pi/180;
        limit(3)=str2double(answer{3});
        maxiter=str2double(answer{4});

        current_figure=handles.current_figure;
        exterior_initial=handles.exterior_initial;
        points_matrix=handles.points_matrix;
        affine_results=handles.affine_results;
        im_names=handles.im_names;
        exterior_initial=handles.exterior_initial;
        control_ground_temp=handles.control_ground;
        interior=handles.interior;
        exterior=handles.exterior;
        project_path=handles.project_path;
        export_option=handles.export_option;

        points_matrix_affine=tranform_measured_points(affine_results,points_matrix,interior);

        control_image_temp=points_matrix_affine(points_matrix_affine(:,1)==current_figure & points_matrix_affine(:,3)==2 & points_matrix_affine(:,6)==1,[2,4,5]);

        control_ground=find_common(control_ground_temp,control_image_temp);
        control_image=find_common(control_image_temp,control_ground_temp);


        [exterior_temp,interior_temp,so,VV,v,iter]=resection_interior(exterior_initial(current_figure,:)...
            ,interior(current_figure,1:3),control_image(:,2:3)...
            ,control_ground(:,2:4),limit,maxiter);

        err=sqrt(diag(VV));

        exterior(current_figure,:)=exterior_temp';
        interior(current_figure,:)=[interior_temp' 0 0];
        set(handles_inner.txt,'String','Exterior orientation computed successfully' );
        handles.exterior=exterior;
        handles.interior=interior;
        show_resection_interior_results(im_names{current_figure},control_image,interior_temp,exterior_temp,err,so,v,iter);
        if export_option
            filename=[project_path 'results\' im_names{current_figure}(1:end-4) '_resection_int.txt'];
            export_resection_interior_results(filename,im_names{current_figure},control_image,interior_temp,exterior_temp,err,so,v,iter);
        end

    end
end

guidata(hObject,handles);

% --------------------------------------------------------------------
function Compute_Exterior_and_Interior_Orientation_with_radial_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

prompt = {'Linear ','Angular (deg)','Linear for Interior ','Maximum Iterations'};
dlg_title = 'Convergence Limit';
num_lines= 1;
def     = {num2str(0.0001),num2str(0.0001),num2str(0.001),num2str(20)};
answer  = inputdlg(prompt,dlg_title,num_lines,def);

if length(answer)
    if ~isnan(str2double(answer))

        limit(1)=str2double(answer{1});
        limit(2)=str2double(answer{2})*pi/180;
        limit(3)=str2double(answer{3});
        maxiter=str2double(answer{4});

        current_figure=handles.current_figure;
        exterior_initial=handles.exterior_initial;
        points_matrix=handles.points_matrix;
        affine_results=handles.affine_results;
        im_names=handles.im_names;
        exterior_initial=handles.exterior_initial;
        control_ground_temp=handles.control_ground;
        interior=handles.interior;
        exterior=handles.exterior;
        project_path=handles.project_path;
        export_option=handles.export_option;

        interior_temp=interior;
        interior_temp(:,4:5)=0;
        points_matrix_affine=tranform_measured_points(affine_results,points_matrix,interior_temp);

        control_image_temp=points_matrix_affine(points_matrix_affine(:,1)==current_figure & points_matrix_affine(:,3)==2 & points_matrix_affine(:,6)==1,[2,4,5]);

        control_ground=find_common(control_ground_temp,control_image_temp);
        control_image=find_common(control_image_temp,control_ground_temp);


        [exterior_temp,interior_temp,so,VV,v,iter]=resection_interior_radial(exterior_initial(current_figure,:)...
            ,interior(current_figure,:),control_image(:,2:3)...
            ,control_ground(:,2:4),limit,maxiter);

        err=sqrt(diag(VV));

        exterior(current_figure,:)=exterior_temp';
        interior(current_figure,:)=interior_temp';
        set(handles_inner.txt,'String','Exterior orientation computed successfully' );
        handles.exterior=exterior;
        handles.interior=interior;
        show_resection_interior_results_radial(im_names{current_figure},control_image,interior_temp,exterior_temp,err,so,v,iter);
        if export_option
            filename=[project_path 'results\' im_names{current_figure}(1:end-4) '_resection_int_dist.txt'];
            export_resection_interior_results_radial(filename,im_names{current_figure},control_image,interior_temp,exterior_temp,err,so,v,iter);
        end

    end
end

guidata(hObject,handles);

% --------------------------------------------------------------------
function Compute_Exterior_interior_DLT_Callback(hObject, eventdata, handles)



% --------------------------------------------------------------------
function Compute_Exterior_interior_DLT_no_radial_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

current_figure=handles.current_figure;
points_matrix=handles.points_matrix;
affine_results=handles.affine_results;
im_names=handles.im_names;
control_ground_temp=handles.control_ground;
interior=handles.interior;
exterior=handles.exterior;
project_path=handles.project_path;
export_option=handles.export_option;
P_all=handles.P_all;

points_matrix_affine=tranform_measured_points(affine_results,points_matrix,interior);

control_image_temp=points_matrix_affine(points_matrix_affine(:,1)==current_figure & points_matrix_affine(:,3)==2 & points_matrix_affine(:,6)==1,[2,4,5]);

control_ground=find_common(control_ground_temp,control_image_temp);
control_image=find_common(control_image_temp,control_ground_temp);

[P,so,VV,v,iter]=DLT(control_image(:,2:3),control_ground(:,2:4),0.001,40);
err=sqrt(diag(VV));
[exterior_temp,interior_temp]=P_2_KRT(P);
P_all(:,:,current_figure)=P;
handles.P_all=P_all;

exterior(current_figure,:)=exterior_temp';
interior(current_figure,:)=[interior_temp 0 0];
set(handles_inner.txt,'String','DLT computed successfully' );
handles.exterior=exterior;
handles.interior=interior;

show_DLT_results(im_names{current_figure},control_image,P,[interior_temp 0 0],exterior_temp,err,so,v,iter);
if export_option
    filename=[project_path 'results\' im_names{current_figure}(1:end-4) '_DLT.txt'];
    export_DLT_results(filename,im_names{current_figure},control_image,P,[interior_temp 0 0],exterior_temp,err,so,v,iter);
end
save ([project_path 'P_all.mat'],'P_all');
guidata(hObject,handles);

% --------------------------------------------------------------------
function Compute_Exterior_interior_DLT_radial_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

current_figure=handles.current_figure;
points_matrix=handles.points_matrix;
affine_results=handles.affine_results;
im_names=handles.im_names;
control_ground_temp=handles.control_ground;
interior=handles.interior;
exterior=handles.exterior;
project_path=handles.project_path;
export_option=handles.export_option;
P_all=handles.P_all;

interior_temp=interior;
interior_temp(:,4:5)=0;

points_matrix_affine=tranform_measured_points(affine_results,points_matrix,interior_temp);

control_image_temp=points_matrix_affine(points_matrix_affine(:,1)==current_figure & points_matrix_affine(:,3)==2 & points_matrix_affine(:,6)==1,[2,4,5]);

control_ground=find_common(control_ground_temp,control_image_temp);
control_image=find_common(control_image_temp,control_ground_temp);

[P,so,VV,v,iter,k1,k2]=DLT_radial(control_image(:,2:3),control_ground(:,2:4),interior(current_figure,:),0.001,40);
err=sqrt(diag(VV));
[exterior_temp,interior_temp]=P_2_KRT(P);
P_all(:,:,current_figure)=P;
handles.P_all=P_all;

exterior(current_figure,:)=exterior_temp';
interior_temp=[interior_temp k1 k2];
interior(current_figure,:)=interior_temp;
set(handles_inner.txt,'String','DLT with radial distortion computed successfully' );
handles.exterior=exterior;
handles.interior=interior;
show_DLT_results_radial(im_names{current_figure},control_image,P,interior_temp,exterior_temp,err,so,v,iter);
if export_option
    filename=[project_path 'results\' im_names{current_figure}(1:end-4) '_DLT_radial.txt'];
    export_DLT_results_radial(filename,im_names{current_figure},control_image,P,interior_temp,exterior_temp,err,so,v,iter);
end

guidata(hObject,handles);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      RELATIVE   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --------------------------------------------------------------------
function Relative_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function Measure_Tie_Points_Callback(hObject, eventdata, handles)

measure_points_pref(1,handles,hObject);

% --------------------------------------------------------------------
function Enter_Initial_Values_Relative_Callback(hObject, eventdata, handles)

%relative_initial=[left_image_number right_image_number by bz omega phi kappa]
handles_inner = guihandles;

stereo_pair=handles.stereo_pair;
relative_initial=handles.relative_initial;
prompt = {'by','bz ','Omega (deg)','Phi (deg)','Kappa (deg)'};
dlg_title = 'Initial Values of Relative Orientation';
num_lines= 1;
dump=0;

relative_initial_temp=relative_initial(relative_initial(:,1)==stereo_pair(1) & ...   %  check if initial values are
    relative_initial(:,2)==stereo_pair(2),3:end); %  already given
if ~isempty(relative_initial_temp)
    dump=1;
    def     = {num2str(relative_initial_temp(1)),num2str(relative_initial_temp(2)),num2str(relative_initial_temp(3)*180/pi),num2str(relative_initial_temp(4)*180/pi),num2str(relative_initial_temp(5)*180/pi)};
    answer  = inputdlg(prompt,dlg_title,num_lines,def);
else
    answer  = inputdlg(prompt,dlg_title,num_lines);
end

if length(answer)
    if ~isnan(str2double(answer))
        relative_initial_temp(1)=str2double(answer{1});
        relative_initial_temp(2)=str2double(answer{2});
        relative_initial_temp(3)=str2double(answer{3});
        relative_initial_temp(4)=str2double(answer{4});
        relative_initial_temp(5)=str2double(answer{5});
        relative_initial_temp(3:5)=relative_initial_temp(3:5)*pi/180;

        if dump==1
            relative_initial(relative_initial(:,1)==stereo_pair(1) & relative_initial(:,2)==stereo_pair(2),3:end)=...
                relative_initial_temp;
        else
            relative_initial=[relative_initial; stereo_pair relative_initial_temp];
        end

        handles.relative_initial=relative_initial;
        set(handles_inner.txt,'String','Initial values of relative orientation entered successfully' );
    end
end

guidata(hObject,handles);

% --------------------------------------------------------------------
function Compute_Relative_Orientation_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

prompt = {'Linear ','Angular (deg)','Maximum Iterations'};
dlg_title = 'Convergence Limit';
num_lines= 1;
def     = {num2str(0.0001),num2str(0.0001),num2str(20)};
answer  = inputdlg(prompt,dlg_title,num_lines,def);

if length(answer)
    if ~isnan(str2double(answer))

        limit(1)=str2double(answer{1});
        limit(2)=str2double(answer{2})*pi/180;
        maxiter=str2double(answer{3});

        stereo_pair=handles.stereo_pair;
        relative_initial=handles.relative_initial;
        relative_results=handles.relative_results;
        points_matrix=handles.points_matrix;
        affine_results=handles.affine_results;
        im_names=handles.im_names;
        interior=handles.interior;
        project_path=handles.project_path;
        export_option=handles.export_option;
        exterior=handles.exterior;

        points_matrix_affine=tranform_measured_points(affine_results,points_matrix,interior);

        tie_image1_temp=points_matrix_affine(points_matrix_affine(:,1)==stereo_pair(1) & points_matrix_affine(:,3)==1 & points_matrix_affine(:,6)==1,[2,4,5]);
        tie_image2_temp=points_matrix_affine(points_matrix_affine(:,1)==stereo_pair(2) & points_matrix_affine(:,3)==1 & points_matrix_affine(:,6)==1,[2,4,5]);

        tie_image1=find_common(tie_image1_temp,tie_image2_temp);
        tie_image2=find_common(tie_image2_temp,tie_image1_temp);

        control_image1_temp=points_matrix_affine(points_matrix_affine(:,1)==stereo_pair(1) & points_matrix_affine(:,3)==2 & points_matrix_affine(:,6)==1,[2,4,5]);
        control_image2_temp=points_matrix_affine(points_matrix_affine(:,1)==stereo_pair(2) & points_matrix_affine(:,3)==2 & points_matrix_affine(:,6)==1,[2,4,5]);

        control_image1=find_common(control_image1_temp,control_image2_temp);
        control_image2=find_common(control_image2_temp,control_image1_temp);

        % Consider control points as tie points
        tie_control_image1=[tie_image1 ; control_image1];
        tie_control_image2=[tie_image2 ; control_image2];

        relative_initial_temp=relative_initial(relative_initial(:,1)==stereo_pair(1) & ...   %
            relative_initial(:,2)==stereo_pair(2),3:end); %

        interior_temp=interior(stereo_pair,:);
        [relative_temp,so,VV,v,iter]=relative(tie_control_image1(:,2:3),tie_control_image2(:,2:3),relative_initial_temp,interior_temp,limit,maxiter);
        err=sqrt(diag(VV));

        set(handles_inner.txt,'String','Relative orientation computed successfully' );

        show_relative_results({im_names{stereo_pair(1)} im_names{stereo_pair(2)}},tie_control_image1,relative_temp,err,so,v,iter);
        if export_option
            filename=[project_path 'results\' im_names{stereo_pair(1)}(1:end-4) '-' im_names{stereo_pair(2)}(1:end-4)  '_relative.txt'];
            export_relative_results(filename,{im_names{stereo_pair(1)} im_names{stereo_pair(2)}},tie_control_image1,relative_temp,err,so,v,iter);
        end


        if max(relative_results(:,1)==stereo_pair(1) & relative_results(:,2)==stereo_pair(2)) % check if relative of this pair is already computed
            relative_results(relative_results(:,1)==stereo_pair(1) & relative_results(:,2)==stereo_pair(2),3:end)=relative_temp;
        else
            relative_results=[relative_results; stereo_pair relative_temp];
        end
        handles.relative_results=relative_results;


        exterior(stereo_pair(1),:)=[0 0 0 0 0 0];
        exterior(stereo_pair(2),:)=[1 relative_temp];
        handles.exterior=exterior;

    end
end

guidata(hObject,handles);


% --------------------------------------------------------------------
function Compute_3D_Model_Coordinates_Relative_Callback(hObject, eventdata, handles)

stereo_pair=handles.stereo_pair;
relative_results=handles.relative_results;
points_matrix=handles.points_matrix;
affine_results=handles.affine_results;
im_names=handles.im_names;
interior=handles.interior;
project_path=handles.project_path;
export_option=handles.export_option;

points_matrix_affine=tranform_measured_points(affine_results,points_matrix,interior);

control_image1_temp=points_matrix_affine(points_matrix_affine(:,1)==stereo_pair(1) & points_matrix_affine(:,3)==2 & points_matrix_affine(:,6)==1,[2,4,5]);
control_image2_temp=points_matrix_affine(points_matrix_affine(:,1)==stereo_pair(2) & points_matrix_affine(:,3)==2 & points_matrix_affine(:,6)==1,[2,4,5]);

tie_image1_temp=points_matrix_affine(points_matrix_affine(:,1)==stereo_pair(1) & points_matrix_affine(:,3)==1 & points_matrix_affine(:,6)==1,[2,4,5]);
tie_image2_temp=points_matrix_affine(points_matrix_affine(:,1)==stereo_pair(2) & points_matrix_affine(:,3)==1 & points_matrix_affine(:,6)==1,[2,4,5]);

control_image1=find_common(control_image1_temp,control_image2_temp);
control_image2=find_common(control_image2_temp,control_image1_temp);

tie_image1=find_common(tie_image1_temp,tie_image2_temp);
tie_image2=find_common(tie_image2_temp,tie_image1_temp);

tie_control_image1=[tie_image1;control_image1];
tie_control_image2=[tie_image2;control_image2];

relative_results_temp=relative_results(relative_results(:,1)==stereo_pair(1) & ...   %
    relative_results(:,2)==stereo_pair(2),3:end); %

interior_temp=interior(stereo_pair,1:3);

% intersection

limit=0.00001;
maxiter=40;
exterior_temp=[0 0 0 0 0 0;1 relative_results_temp];
for i=1:size(tie_control_image1,1)
    x1=tie_control_image1(i,2);
    y1=tie_control_image1(i,3);
    x2=tie_control_image2(i,2);
    y2=tie_control_image2(i,3);
    [XYZ,so,VV,v,iter]=intersection(exterior_temp,interior_temp,x1,y1,x2,y2,limit,maxiter);
    tie_control_model(i,1)=tie_control_image1(i,1);% code
    tie_control_model(i,2:4)=XYZ;
    residuals(i,1:4)=v';
    err=sqrt(diag(VV));
    errors(i,1:3)=err';
    errors(i,4)=so;
end

handles.tie_control_model=tie_control_model;
show_intersection_results(im_names,tie_control_model,errors,residuals);

if export_option
    filename=[project_path 'results\' im_names{stereo_pair(1)}(1:end-4) '-' im_names{stereo_pair(2)}(1:end-4)  '_tie_control_model.txt'];
    export_intersection_results(filename,im_names,tie_control_model,errors,residuals);
end

guidata(hObject,handles);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      Absolute     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




% --------------------------------------------------------------------
function Absolute_Callback(hObject, eventdata, handles)

% --------------------------------------------------------------------
function Enter_Initial_Values_Absolute_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

stereo_pair=handles.stereo_pair;
absolute_initial=handles.absolute_initial;
prompt = {'k','OMEGA (deg)','PHI (deg)','KAPPA (deg)','tx','ty','tz'};
dlg_title = 'Initial Values of Absolute Orientation';
num_lines= 1;
dump=0;

absolute_initial_temp=absolute_initial(absolute_initial(:,1)==stereo_pair(1) & ...   %  check if initial values are
    absolute_initial(:,2)==stereo_pair(2),3:end); %  already given
if ~isempty(absolute_initial_temp)
    dump=1;
    def     = {num2str(absolute_initial_temp(1)),num2str(absolute_initial_temp(2)*180/pi),num2str(absolute_initial_temp(3)*180/pi),num2str(absolute_initial_temp(4)*180/pi),num2str(absolute_initial_temp(5)),num2str(absolute_initial_temp(6)),num2str(absolute_initial_temp(7))};
    answer  = inputdlg(prompt,dlg_title,num_lines,def);
else
    answer  = inputdlg(prompt,dlg_title,num_lines);
end

if length(answer)
    if ~isnan(str2double(answer))
        absolute_initial_temp(1)=str2double(answer{1});
        absolute_initial_temp(2)=str2double(answer{2});
        absolute_initial_temp(3)=str2double(answer{3});
        absolute_initial_temp(4)=str2double(answer{4});
        absolute_initial_temp(5)=str2double(answer{5});
        absolute_initial_temp(6)=str2double(answer{6});
        absolute_initial_temp(7)=str2double(answer{7});
        absolute_initial_temp(2:4)=absolute_initial_temp(2:4)*pi/180;

        if dump==1
            absolute_initial(absolute_initial(:,1)==stereo_pair(1) & absolute_initial(:,2)==stereo_pair(2),3:end)=...
                absolute_initial_temp;
        else
            absolute_initial=[absolute_initial; stereo_pair absolute_initial_temp];
        end

        handles.absolute_initial=absolute_initial;
        set(handles_inner.txt,'String','Initial values of absolute orientation entered successfully' );
    end
end

guidata(hObject,handles);

% --------------------------------------------------------------------
function Compute_Absolute_Orientation_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

prompt = {'Linear ','Angular (deg)','Maximum Iterations'};
dlg_title = 'Convergence Limit';
num_lines= 1;
def     = {num2str(0.0001),num2str(0.0001),num2str(20)};
answer  = inputdlg(prompt,dlg_title,num_lines,def);

if length(answer)
    if ~isnan(str2double(answer))

        limit(1)=str2double(answer{1});
        limit(2)=str2double(answer{2})*pi/180;
        maxiter=str2double(answer{3});

        stereo_pair=handles.stereo_pair;
        absolute_initial=handles.absolute_initial;
        relative_results=handles.relative_results;
        absolute_results=handles.absolute_results;
        points_matrix=handles.points_matrix;
        affine_results=handles.affine_results;
        im_names=handles.im_names;
        interior=handles.interior;
        exterior=handles.exterior;
        control_ground_temp=handles.control_ground;
        project_path=handles.project_path;
        export_option=handles.export_option;

        points_matrix_affine=tranform_measured_points(affine_results,points_matrix,interior);

        control_image1_temp=points_matrix_affine(points_matrix_affine(:,1)==stereo_pair(1) & points_matrix_affine(:,3)==2 & points_matrix_affine(:,6)==1,[2,4,5]);
        control_image2_temp=points_matrix_affine(points_matrix_affine(:,1)==stereo_pair(2) & points_matrix_affine(:,3)==2 & points_matrix_affine(:,6)==1,[2,4,5]);

        control_image1=find_common(control_image1_temp,control_image2_temp);
        control_image2=find_common(control_image2_temp,control_image1_temp);

        control_ground=find_common(control_ground_temp,control_image1);
        control_image1=find_common(control_image1,control_ground);
        control_image2=find_common(control_image2,control_ground);

        relative_results_temp=relative_results(relative_results(:,1)==stereo_pair(1) & ...   %
            relative_results(:,2)==stereo_pair(2),3:end); %


        absolute_initial_temp=absolute_initial(absolute_initial(:,1)==stereo_pair(1) & ...   %
            absolute_initial(:,2)==stereo_pair(2),3:end); %

        interior_temp=interior(stereo_pair,1:3);

        % intersection
        exterior_temp=[0 0 0 0 0 0;1 relative_results_temp];
        for i=1:size(control_ground,1)
            x1=control_image1(i,2);
            y1=control_image1(i,3);
            x2=control_image2(i,2);
            y2=control_image2(i,3);
            [XYZ,so,VV,v,iter]=intersection(exterior_temp,interior_temp,x1,y1,x2,y2,limit,maxiter);
            control_model(i,1)=control_ground(i,1);% code
            control_model(i,2:4)=XYZ;
        end

        % Absolute
        [absolute_results_temp,so,VV,v,iter]=absolute(absolute_initial_temp,control_model(:,2:4),...
            control_ground(:,2:4),limit,maxiter);
        err=sqrt(diag(VV));

        % Exteriors from absolute
        exterior_1=[absolute_results_temp(5:7); absolute_results_temp(2:4)];
        R=R_from_angles(absolute_results_temp(2), absolute_results_temp(3), absolute_results_temp(4));
        exterior_2=absolute_results_temp(1)*R'*[1;relative_results_temp(1);relative_results_temp(2)]+...
            [absolute_results_temp(5),absolute_results_temp(6),absolute_results_temp(7)]';
        Rrel=R_from_angles(relative_results_temp(3), relative_results_temp(4), relative_results_temp(5));
        R2=Rrel*R;
        [temp1,temp2,temp3]=angles_from_R(R2);

        exterior_2(4)=temp1(1);
        exterior_2(5)=temp2(1);
        exterior_2(6)=temp3(1);
        exterior(stereo_pair(1),:)=exterior_1';
        exterior(stereo_pair(2),:)=exterior_2';
        handles.exterior=exterior;

        set(handles_inner.txt,'String','Absolute orientation computed successfully' );

        show_absolute_results(im_names,control_model,exterior_1,exterior_2,absolute_results_temp,err,so,v,iter);
        if export_option
            filename=[project_path 'results\' im_names{stereo_pair(1)}(1:end-4) '-' im_names{stereo_pair(2)}(1:end-4)  '_absolute.txt'];
            export_absolute_results(filename,im_names,control_model,exterior_1,exterior_2,absolute_results_temp,err,so,v,iter);
        end

        if max(absolute_results(:,1)==stereo_pair(1) & absolute_results(:,2)==stereo_pair(2)) % check if absolute of this pair is already computed
            absolute_results(absolute_results(:,1)==stereo_pair(1) & absolute_results(:,2)==stereo_pair(2),3:end)=absolute_results_temp;
        else
            absolute_results=[absolute_results; stereo_pair absolute_results_temp'];
        end
        handles.absolute_results=absolute_results;
    end
end

guidata(hObject,handles);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      VECTORISATION    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% --------------------------------------------------------------------
function Vectorisation_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function Measure_Points_Vectorisation_Callback(hObject, eventdata, handles)

measure_points_pref(10,handles,hObject);

% --------------------------------------------------------------------
function Measure_Lines_Vectorisation_Callback(hObject, eventdata, handles)

measure_lines_pref(10,handles,hObject);

% --------------------------------------------------------------------
function Show_3D_Callback(hObject, eventdata, handles)

prompt = {'Linear ','Maximum Iterations'};
dlg_title = 'Convergence Limit';
num_lines= 1;
def     = {num2str(0.0001),num2str(20)};
answer  = inputdlg(prompt,dlg_title,num_lines,def);

if length(answer)
    if ~isnan(str2double(answer))

        limit(1)=str2double(answer{1});
        maxiter=str2double(answer{2});

        stereo_pair=handles.stereo_pair;
        points_matrix=handles.points_matrix;
        lines_matrix=handles.lines_matrix;
        affine_results=handles.affine_results;
        im_names=handles.im_names;
        interior=handles.interior;
        exterior=handles.exterior;
        project_path=handles.project_path;
        export_option=handles.export_option;

        points_matrix_affine=tranform_measured_points(affine_results,points_matrix,interior);
        lines_matrix_affine=tranform_measured_lines(affine_results,lines_matrix,interior);

        vectpoints_image1_temp=points_matrix_affine(points_matrix_affine(:,1)==stereo_pair(1) & points_matrix_affine(:,3)==10,[2,4,5]);
        vectpoints_image2_temp=points_matrix_affine(points_matrix_affine(:,1)==stereo_pair(2) & points_matrix_affine(:,3)==10,[2,4,5]);

        vectpoints_image1=find_common(vectpoints_image1_temp,vectpoints_image2_temp);
        vectpoints_image2=find_common(vectpoints_image2_temp,vectpoints_image1_temp);


        interior_temp=interior(stereo_pair,1:3);
        exterior_temp=exterior(stereo_pair,:);

        for i=1:size(vectpoints_image1,1)
            x1=vectpoints_image1(i,2);
            y1=vectpoints_image1(i,3);
            x2=vectpoints_image2(i,2);
            y2=vectpoints_image2(i,3);

            [XYZ,so,VV,v,iter]=intersection(exterior_temp,interior_temp,x1,y1,x2,y2,limit,maxiter);
            points_3D(i,1)=vectpoints_image1(i,1);% code
            points_3D(i,2:4)=XYZ;
            residuals(i,1:4)=v';
            err=sqrt(diag(VV));
            errors(i,1:3)=err';
            errors(i,4)=so;
        end

        handles.points_3D=points_3D;
        show_intersection_results(im_names,points_3D,errors,residuals);

        if export_option
            filename=[project_path 'results\' im_names{stereo_pair(1)}(1:end-4) '-' im_names{stereo_pair(2)}(1:end-4)  '_3Dpoints.txt'];
            export_intersection_results(filename,im_names,points_3D,errors,residuals);
        end


        vectlines_image1=lines_matrix_affine(lines_matrix_affine(:,1)==stereo_pair(1) & lines_matrix_affine(:,2)==10, 3:6);
        vectlines_image2=lines_matrix_affine(lines_matrix_affine(:,1)==stereo_pair(2) & lines_matrix_affine(:,2)==10, 3:6);

        %         vectlines_image1=find_common(vectlines_image1_temp,vectlines_image2_temp);
        %         vectlines_image2=find_common(vectlines_image2_temp,vectlines_image1_temp);

        for i=1:size(vectlines_image1,1)
            x1=vectlines_image1(i,3);
            y1=vectlines_image1(i,4);
            x2=vectlines_image2(i,3);
            y2=vectlines_image2(i,4);

            [XYZ,so,VV,v,iter]=intersection(exterior_temp,interior_temp,x1,y1,x2,y2,limit,maxiter);
            lines_3D(i,1:2)=vectlines_image1(i,1:2);% code
            lines_3D(i,3:5)=XYZ;
            residuals(i,1:4)=v';
            err=sqrt(diag(VV));
            errors(i,1:3)=err';
            errors(i,4)=so;
        end

        handles.lines_3D=lines_3D;
        show_intersection_results_lines(lines_3D(:,[1 3 4 5]),errors,residuals);
        if export_option
            filename=[project_path 'results\' im_names{stereo_pair(1)}(1:end-4) '-' im_names{stereo_pair(2)}(1:end-4)  '_3Dlines.txt'];
            export_intersection_results_lines(filename,lines_3D(:,[1 3 4 5]),errors,residuals);
        end

        fig_num=size(im_names,2)+1;
        plot3D_points_lines(fig_num,points_3D,lines_3D);
    end
end

guidata(hObject,handles);

% --------------------------------------------------------------------
function Export_DXF_Callback(hObject, eventdata, handles)

text_size=handles.text_size;
points_3D=handles.points_3D;
lines_3D=handles.lines_3D;

make_dxf_points_lines(points_3D,lines_3D,text_size);

guidata(hObject,handles);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      PROJECTIVE 2D  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% --------------------------------------------------------------------
function Projective_2D_Callback(hObject, eventdata, handles)



% --------------------------------------------------------------------
function Measure_Control_Points_Projective_Callback(hObject, eventdata, handles)

measure_points_pref(11,handles,hObject);

% --------------------------------------------------------------------
function Import_Control_Points_Coordinates_Projective_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

[a b]=uigetfile({'*.txt',  'Text Files (*.txt)'; '*.*',  'All Files (*.*)';},'Select file of control-points in ground-coordinates');

if size(a,2)>1
    current_figure=handles.current_figure;
    control_ground_projective_2D=load([b a]);
    control_ground_projective_2D=sortrows(control_ground_projective_2D,1);
    handles.control_ground_projective_2D=control_ground_projective_2D;
    set(handles_inner.txt,'String','Ground-coordinates loaded successfully' );
end

guidata(hObject,handles);

% --------------------------------------------------------------------
function Compute_2D_Projective_Transformation_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function Compute_2D_Projective_Transformation_no_radial_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

current_figure=handles.current_figure;
points_matrix=handles.points_matrix;
affine_results=handles.affine_results;
im_names=handles.im_names;
control_ground_temp=handles.control_ground_projective_2D;
interior=handles.interior;
project_path=handles.project_path;
export_option=handles.export_option;
H_all=handles.H_all;

points_matrix_affine=tranform_measured_points(affine_results,points_matrix,interior);
control_image_temp=points_matrix_affine(points_matrix_affine(:,1)==current_figure & points_matrix_affine(:,3)==11 & points_matrix_affine(:,6)==1,[2,4,5]);

control_ground=find_common(control_ground_temp,control_image_temp);
control_image=find_common(control_image_temp,control_ground_temp);

[H,so,VV,v,iter]=projective_2D(control_ground(:,2:3),control_image(:,2:3),0.001,40);
err=sqrt(diag(VV));
H_all(:,:,current_figure)=H;
handles.H_all=H_all;

set(handles_inner.txt,'String','2D Projective Tranformation computed successfully' );



% Compute residuals for disabled points
control_image_temp_dis=points_matrix_affine(points_matrix_affine(:,1)==current_figure & points_matrix_affine(:,3)==11 & points_matrix_affine(:,6)==0,[2,4,5]);
control_ground_temp_dis=handles.control_ground_projective_2D;

control_ground_dis=find_common(control_ground_temp_dis,control_image_temp_dis);
control_image_dis=find_common(control_image_temp_dis,control_ground_temp_dis);

if ~isempty(control_image_dis)
    control_ground_dis(:,4)=1;
    control_image_dis(:,4)=1;
    control_ground_dis_reprojection=control_ground_dis;
    v2=zeros(2*size(control_ground_dis,1),1);
    for i=1:size(control_ground_dis,1)
        control_ground_dis_reprojection(i,2:4)=(H*control_image_dis(i,2:4)');
        control_ground_dis_reprojection(i,2:4)=control_ground_dis_reprojection(i,2:4)/control_ground_dis_reprojection(i,4);
        v2(2*i-1)=control_ground_dis(i,2)-control_ground_dis_reprojection(i,2);
        v2(2*i)=control_ground_dis(i,3)-control_ground_dis_reprojection(i,3);
    end
    control_ground_dis_reprojection(:,4)=[];
    v=[v;v2];
    control_image=[control_image;control_ground_dis_reprojection];
end






show_2D_Projective_results(im_names{current_figure},control_image,H,err,so,v,iter);
if export_option
    filename=[project_path 'results\' im_names{current_figure}(1:end-4) '_2D_Projective.txt'];
    export_2D_Projective_results(filename,im_names{current_figure},control_image,H,err,so,v,iter);
end

guidata(hObject,handles);

% --------------------------------------------------------------------
function Compute_2D_Projective_Transformation_radial_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

current_figure=handles.current_figure;
points_matrix=handles.points_matrix;
affine_results=handles.affine_results;
im_names=handles.im_names;
control_ground_temp=handles.control_ground_projective_2D;
interior=handles.interior;
project_path=handles.project_path;
export_option=handles.export_option;
H_all=handles.H_all;

interior_temp=interior;
interior_temp(:,4:5)=0;

points_matrix_affine=tranform_measured_points(affine_results,points_matrix,interior);
control_image_temp=points_matrix_affine(points_matrix_affine(:,1)==current_figure & points_matrix_affine(:,3)==11 & points_matrix_affine(:,6)==1,[2,4,5]);

control_ground=find_common(control_ground_temp,control_image_temp);
control_image=find_common(control_image_temp,control_ground_temp);

[H,k1,k2,so,VV,v,iter]=projective_2D_radial(control_ground(:,2:3),control_image(:,2:3),interior(current_figure,:),0.001,40);
err=sqrt(diag(VV));
H_all(:,:,current_figure)=H;
handles.H_all=H_all;

set(handles_inner.txt,'String','2D Projective Tranformation with radial distortion computed successfully' );

interior(current_figure,:)=[interior(current_figure,1:3) k1 k2];
handles.interior=interior;

show_2D_Projective_results_radial(im_names{current_figure},control_image,H,err,[0 0 0 k1 k2],so,v,iter);
if export_option
    filename=[project_path 'results\' im_names{current_figure}(1:end-4) '_2D_Projective_dist.txt'];
    export_2D_Projective_results_radial(filename,im_names{current_figure},control_image,H,err,[0 0 0 k1 k2],so,v,iter);
end

guidata(hObject,handles);

% --------------------------------------------------------------------
function Measure_Points_Projective_Callback(hObject, eventdata, handles)

measure_points_pref(12,handles,hObject);

% --------------------------------------------------------------------
function Measure_Lines_Projective_Callback(hObject, eventdata, handles)

measure_lines_pref(12,handles,hObject);

% --------------------------------------------------------------------
function Show_2D_Projective_Callback(hObject, eventdata, handles)

current_figure=handles.current_figure;
points_matrix=handles.points_matrix;
lines_matrix=handles.lines_matrix;
im_names=handles.im_names;
project_path=handles.project_path;
export_option=handles.export_option;
H_all=handles.H_all;
H=H_all(:,:,current_figure);
interior=handles.interior;
affine_results=handles.affine_results;

points_matrix_affine=tranform_measured_points(affine_results,points_matrix,interior(current_figure,:));
lines_matrix_affine=tranform_measured_lines(affine_results,lines_matrix,interior(current_figure,:));

points_matrix_temp=points_matrix_affine(points_matrix_affine(:,1)==current_figure & points_matrix_affine(:,3)==12 & points_matrix_affine(:,6)==1,:);
lines_matrix_temp=lines_matrix_affine(lines_matrix_affine(:,1)==current_figure & lines_matrix_affine(:,2)==12,:);

points_matrix_temp2=[points_matrix_temp(:,1:3),zeros(size(points_matrix_temp,1),2),points_matrix_temp(:,4:end)];
lines_matrix_temp2=[lines_matrix_temp(:,1:4),zeros(size(lines_matrix_temp,1),2),lines_matrix_temp(:,5:end)];

points_matrix_projective=tranform_measured_points_projective(H,points_matrix_temp2);
lines_matrix_projective=tranform_measured_lines_projective(H,lines_matrix_temp2);

if ~isempty(points_matrix_projective)
    figure(size(im_names,1)+current_figure+3);
    points_matrix_projective=plot_points_matrix(points_matrix_projective,current_figure);
end
if ~isempty(lines_matrix_projective)
    lines_matrix_projective=plot_lines_matrix(lines_matrix_projective,current_figure);
end

points_2D=points_matrix_projective(:,[2 6 7]);
points_2D(:,4)=0;
lines_2D=lines_matrix_projective(:,[3 4 7 8]);
lines_2D(:,5)=0;
handles.points_2D=points_2D;
handles.lines_2D=lines_2D;

guidata(hObject,handles);

% --------------------------------------------------------------------
function Export_DXF_2D_Projective_Callback(hObject, eventdata, handles)

points_2D=handles.points_2D;
lines_2D=handles.lines_2D;
text_size=handles.text_size;

make_dxf_points_lines(points_2D,lines_2D,text_size);

guidata(hObject,handles);


% --------------------------------------------------------------------
function Resample_projective_Callback(hObject, eventdata, handles)

current_figure=handles.current_figure;
im_names=handles.im_names;
project_path=handles.project_path;
export_option=handles.export_option;
H_all=handles.H_all;
H=H_all(:,:,current_figure);

prompt = {'Ground Element',};
dlg_title = 'Ground Element size';
num_lines= 1;
% def     = {num2str(0.1)};
% answer  = inputdlg(prompt,dlg_title,num_lines,def);
answer  = inputdlg(prompt,dlg_title,num_lines);

if length(answer)
    if ~isnan(str2double(answer))
        groundel_size=str2double(answer{1});
        im_original=imread(im_names{current_figure});
        im_rect=rectify_image(im_original,H,groundel_size);
        clear im_original;
        figure(10),imshow(im_rect);


        [file_name file_path]=uiputfile({'*.jpg',  'Image File (*.jpg)'; '*.*',  'All Files (*.*)';},'Save Rectified Image');

        if file_name~=0
            imwrite(im_rect,[file_path file_name]);
        end
    end
end





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      TOOLS    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% --------------------------------------------------------------------
function Tools_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function Filter_Points_Callback(hObject, eventdata, handles)

handles.han_change_points_matrix=@change_points_matrix;
handles.hObj=hObject;
guidata(hObject,handles);

point_filter(handles,hObject);

% --------------------------------------------------------------------
function switch_functions_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

photogrammetric_switch=handles.photogrammetric_switch;

if photogrammetric_switch==1
    set(handles_inner.Interior,'Visible','off');
    set(handles_inner.Resection,'Visible','off');
    set(handles_inner.Relative,'Visible','off');
    set(handles_inner.Absolute,'Visible','off');
    set(handles_inner.Vectorisation,'Visible','off');
    set(handles_inner.Projective_2D,'Visible','off');
    handles.photogrammetric_switch=0;
else
    set(handles_inner.Interior,'Visible','on');
    set(handles_inner.Resection,'Visible','on');
    set(handles_inner.Relative,'Visible','on');
    set(handles_inner.Absolute,'Visible','on');
    set(handles_inner.Vectorisation,'Visible','on');
    set(handles_inner.Projective_2D,'Visible','on');
    handles.photogrammetric_switch=1;
end

guidata(hObject,handles);

% --------------------------------------------------------------------
function select_stereo_pair_Callback(hObject, eventdata, handles)
handles_inner = guihandles;

stereo_pair=handles.stereo_pair;
prompt = {'Left Image','Right Image'};
dlg_title = 'Select Stereo Pair';
num_lines= 1;

def     = {num2str(stereo_pair(1)),num2str(stereo_pair(2))};
answer  = inputdlg(prompt,dlg_title,num_lines,def);

if length(answer)
    if ~isnan(str2double(answer))
        stereo_pair(1)=str2double(answer{1});
        stereo_pair(2)=str2double(answer{2});
        handles.stereo_pair=stereo_pair;
        set(handles_inner.txt,'String','Stere Pair selected successfully' );
    end
end

guidata(hObject,handles);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      HELP     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% --------------------------------------------------------------------
function Help_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function About_Callback(hObject, eventdata, handles)

about;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      FUNCTIONS    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function measure_lines_pref(line_id,handles,hObject)
handles_inner = guihandles;

dump={'' '' '' '' '' '' '' '' '' 'Line Vectorisation' '' 'Line Vectorisation'};
set(handles_inner.btn_measure_line,'Enable','on');
set(handles_inner.btn_delete,'Enable','on');
set(handles_inner.btn_measure_point,'Enable','off');
handles.option_measure=2;
handles.line_id=line_id;
% set(handles.editbox_vp,'Visible','off');
set(handles_inner.btn_end_of_measurements,'Enable','on');
set(handles_inner.editbox_point_code,'Enable','on');
set(handles_inner.txt_id,'String',dump{line_id});

guidata(hObject,handles);

% --------------------------------------------------------------------
function measure_points_pref(pnt_id,handles,hObject)
handles_inner = guihandles;

dump={'Tie' 'Control' '' '' '' '' '' '' 'Fiducial' 'Point Vectorisation' 'Control' 'Point Vectorisation'};
set(handles_inner.btn_measure_line,'Enable','off');
set(handles_inner.btn_measure_point,'Visible','on','Enable','on');
% set(handles.editbox_vp,'Visible','off');
set(handles_inner.btn_delete,'Enable','on');
set(handles_inner.btn_end_of_measurements,'Enable','on');
set(handles_inner.editbox_point_code,'Enable','on');
set(handles_inner.txt_id,'String',dump{pnt_id});
handles.option_measure=1;
handles.pnt_id=pnt_id;

guidata(hObject,handles);


function change_points_matrix(points_matrix,hObject,handles);

handles.points_matrix=points_matrix;
guidata(hObject,handles);


