function lines_matrix=plot_lines_matrix(lines_matrix,image_number)

% lines_matrix=[image_number    line_id    line_code    pnt_code   line_handle(text_handle for first point)   pnt_handle    x(pixels)    y(pixels)]
% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% December 2004

point_color={'b+' 'r+' 'g+' 'c+' 'r+' 'r+' 'r+' 'r+' 'b+' 'k+' 'k+' 'k+'}; 
line_color={'b' 'r' 'g' 'c' 'r' 'r' 'r' 'r' 'b' 'k' 'k' 'k'}; 

lines_matrix_rows=find(lines_matrix(:,1)==image_number);   % finds the lines of lines_matrix refering to image: image_number 

if ~isempty(lines_matrix_rows)
    lines_in_image=lines_matrix(lines_matrix_rows,:);
    lines_matrix(lines_matrix_rows,:)=[];                      % deletes these lines

    lines_in_image=sortrows(lines_in_image,4);
    lines_in_image=sortrows(lines_in_image,3);

    temp1=diff(lines_in_image(:,3));
    temp1(end+1)=1;
    lines_codes=lines_in_image(temp1~=0,3);
    lines_number=size(lines_codes,1);

    % figure(image_number);
    hold on;

    for j=1:lines_number
        temp_rows=find(lines_in_image(:,3)==lines_codes(j));
        one_line=lines_in_image(temp_rows,:);

        line_handle(1)=text(one_line(1,7),one_line(1,8),num2str(lines_codes(j)),'Color',line_color{one_line(1,2)},'FontSize',8);
        pnt_handle(1)=plot(one_line(1,7),one_line(1,8),point_color{one_line(1,2)});

        for i=1:size(one_line,1)-1
            line_handle(i+1)=line(one_line(i:i+1,7),one_line(i:i+1,8),'Color',line_color{one_line(i,2)},'LineWidth',.4);
            pnt_handle(i+1)=plot(one_line(i+1,7),one_line(i+1,8),point_color{one_line(i+1,2)});
        end
        lines_in_image(temp_rows,5)=line_handle';
        lines_in_image(temp_rows,6)=pnt_handle';
    end

    lines_matrix=[lines_matrix;lines_in_image];
end