function [H,k1,k2,so,VV,v,iter]=projective_2D_radial(Xground,ximage,interior_initial,limit,maxiter)
% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% December 2004
% ximage=[x1 y1;x2 y2;...;xn yn]
% Xground=[X1 Y1 Z1;...;Xn Yn Zn]

for i=1:size(Xground,1)

    L(2*i-1,1)=ximage(i,1);
    L(2*i,1)=ximage(i,2);

    A(2*i-1,1)=Xground(i,1);
    A(2*i-1,2)=Xground(i,2);
    A(2*i-1,3)=1;
    A(2*i-1,4)=0;
    A(2*i-1,5)=0;
    A(2*i-1,6)=0;
    A(2*i-1,7)=-ximage(i,1)*Xground(i,1);
    A(2*i-1,8)=-ximage(i,1)*Xground(i,2);
    
    A(2*i,1)=0;
    A(2*i,2)=0;
    A(2*i,3)=0;
    A(2*i,4)=Xground(i,1);
    A(2*i,5)=Xground(i,2);
    A(2*i,6)=1;
    A(2*i,7)=-ximage(i,2)*Xground(i,1);
    A(2*i,8)=-ximage(i,2)*Xground(i,2);
    
end
h=inv(A'*A)*(A'*L);

h(9)=interior_initial(4);
h(10)=interior_initial(5);
xo=interior_initial(2);
yo=interior_initial(3);

iter=1;
so1=1;so2=200000;
while abs((so2-so1)/so1)>limit
    if iter>=maxiter-1
        break
    end

    so1=so2;
    
    for i=1:size(Xground,1)

        x=Xground(i,1);
        y=Xground(i,2);

        % Observation Matrix
        tempX=(h(1)*x+h(2)*y+h(3))/(h(7)*x+h(8)*y+1);
        tempY=(h(4)*x+h(5)*y+h(6))/(h(7)*x+h(8)*y+1);
        
        k1=h(9);
        k2=h(10);
        distr2=((ximage(i,1)-xo)^2+(ximage(i,2)-yo)^2);
        distdx=(ximage(i,1)-xo)*((k1*distr2)+(k2*(distr2)^2));
        distdy=(ximage(i,2)-yo)*((k1*distr2)+(k2*(distr2)^2));

        L(2*i-1,1)=ximage(i,1)-tempX-distdx;
        L(2*i,1)=ximage(i,2)-tempY-distdy;

       
        dif_x_h1=x/(h(7)*x+h(8)*y+1);
        dif_x_h2=y/(h(7)*x+h(8)*y+1);
        dif_x_h3=1/(h(7)*x+h(8)*y+1);
        dif_x_h4=0;
        dif_x_h5=0;
        dif_x_h6=0;
        dif_x_h7=-(h(1)*x+h(2)*y+h(3))/(h(7)*x+h(8)*y+1)^2*x;
        dif_x_h8=-(h(1)*x+h(2)*y+h(3))/(h(7)*x+h(8)*y+1)^2*y;
        dif_x_k1=distr2*(ximage(i,1)-xo);
        dif_x_k2=distr2^2*(ximage(i,1)-xo);

        dif_y_h1=0;
        dif_y_h2=0;
        dif_y_h3=0;
        dif_y_h4=x/(h(7)*x+h(8)*y+1);
        dif_y_h5=y/(h(7)*x+h(8)*y+1);
        dif_y_h6=1/(h(7)*x+h(8)*y+1);
        dif_y_h7=-(h(4)*x+h(5)*y+h(6))/(h(7)*x+h(8)*y+1)^2*x;
        dif_y_h8=-(h(4)*x+h(5)*y+h(6))/(h(7)*x+h(8)*y+1)^2*y;
        dif_y_k1=distr2*(ximage(i,2)-yo);
        dif_y_k2=distr2^2*(ximage(i,2)-yo);


        % Design Matrix A
        A(2*i-1,1)=dif_x_h1;
        A(2*i-1,2)=dif_x_h2;
        A(2*i-1,3)=dif_x_h3;
        A(2*i-1,4)=dif_x_h4;
        A(2*i-1,5)=dif_x_h5;
        A(2*i-1,6)=dif_x_h6;
        A(2*i-1,7)=dif_x_h7;
        A(2*i-1,8)=dif_x_h8;
        A(2*i-1,9)=dif_x_k1;
        A(2*i-1,10)=dif_x_k2;
        
        A(2*i,1)=dif_y_h1;
        A(2*i,2)=dif_y_h2;
        A(2*i,3)=dif_y_h3;
        A(2*i,4)=dif_y_h4;
        A(2*i,5)=dif_y_h5;
        A(2*i,6)=dif_y_h6;
        A(2*i,7)=dif_y_h7;
        A(2*i,8)=dif_y_h8;
        A(2*i,9)=dif_y_k1;
        A(2*i,10)=dif_y_k2;

    end

    % Least Squares Solution
    dX=inv(A'*A)*(A'*L);
    v=L-A*dX;
    so2=sqrt(v'*v/(2*size(Xground,1)-10));
    h=h+dX;
    iter=iter+1;
    
end
so=so2;
VV=so^2*inv(A'*A);
H=reshape([h(1:8);1],3,3)';
H=inv(H);
H=H./H(3,3);
k1=h(9);
k2=h(10);

