function [H,so,VV,v]=projective_2D(Xground,ximage)
% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% December 2004
% ximage=[x1 y1;x2 y2;...;xn yn]
% Xground=[X1 Y1;...;Xn Yn]
% Xground=H*ximage

for i=1:size(ximage,1)

    L(2*i-1,1)=Xground(i,1);
    L(2*i,1)=Xground(i,2);

    A(2*i-1,1)=ximage(i,1);
    A(2*i-1,2)=ximage(i,2);
    A(2*i-1,3)=1;
    A(2*i-1,4)=0;
    A(2*i-1,5)=0;
    A(2*i-1,6)=0;
    A(2*i-1,7)=-Xground(i,1)*ximage(i,1);
    A(2*i-1,8)=-Xground(i,1)*ximage(i,2);
    
    A(2*i,1)=0;
    A(2*i,2)=0;
    A(2*i,3)=0;
    A(2*i,4)=ximage(i,1);
    A(2*i,5)=ximage(i,2);
    A(2*i,6)=1;
    A(2*i,7)=-Xground(i,2)*ximage(i,1);
    A(2*i,8)=-Xground(i,2)*ximage(i,2);
    
end
dX=inv(A'*A)*(A'*L);

v=L-A*dX;
if size(ximage,1)>4
    so=sqrt(v'*v/(2*size(ximage,1)-8));
    VV=so^2*inv(A'*A);
else 
    so=[];
    VV=[];
end

dX(9,1)=1;
H=reshape(dX,3,3)';


