function [H,so,VV,v,iter]=projective_2Dbeta(ximage,Xground,limit,maxiter)
% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% December 2004
% ximage=[x1 y1;x2 y2;...;xn yn]
% Xground=[X1 Y1 Z1;...;Xn Yn Zn]

for i=1:size(ximage,1)

    L(2*i-1,1)=Xground(i,1);
    L(2*i,1)=Xground(i,2);

    A(2*i-1,1)=ximage(i,1);
    A(2*i-1,2)=ximage(i,2);
    A(2*i-1,3)=1;
    A(2*i-1,4)=0;
    A(2*i-1,5)=0;
    A(2*i-1,6)=0;
    A(2*i-1,7)=-Xground(i,1)*ximage(i,1);
    A(2*i-1,8)=-Xground(i,1)*ximage(i,2);
    
    A(2*i,1)=0;
    A(2*i,2)=0;
    A(2*i,3)=0;
    A(2*i,4)=ximage(i,1);
    A(2*i,5)=ximage(i,2);
    A(2*i,6)=1;
    A(2*i,7)=-Xground(i,2)*ximage(i,1);
    A(2*i,8)=-Xground(i,2)*ximage(i,2);
    
end
h=inv(A'*A)*(A'*L);

iter=1;
so1=1;so2=200000;
while abs((so2-so1)/so1)>limit
    if iter>=maxiter-1
        break
    end

    so1=so2;
    
    for i=1:size(ximage,1)

        x=ximage(i,1);
        y=ximage(i,2);
        
        dif_x_h1=x/(h(7)*x+h(8)*y+1);
        dif_x_h2=y/(h(7)*x+h(8)*y+1);
        dif_x_h3=1/(h(7)*x+h(8)*y+1);
        dif_x_h4=0;
        dif_x_h5=0;
        dif_x_h6=0;
        dif_x_h7=-(h(1)*x+h(2)*y+h(3))/(h(7)*x+h(8)*y+1)^2*x;
        dif_x_h8=-(h(1)*x+h(2)*y+h(3))/(h(7)*x+h(8)*y+1)^2*y;

        dif_y_h1=0;
        dif_y_h2=0;
        dif_y_h3=0;
        dif_y_h4=x/(h(7)*x+h(8)*y+1);
        dif_y_h5=y/(h(7)*x+h(8)*y+1);
        dif_y_h6=1/(h(7)*x+h(8)*y+1);
        dif_y_h7=-(h(4)*x+h(5)*y+h(6))/(h(7)*x+h(8)*y+1)^2*x;
        dif_y_h8=-(h(4)*x+h(5)*y+h(6))/(h(7)*x+h(8)*y+1)^2*y;


        % Design Matrix A
        A(2*i-1,1)=dif_x_h1;
        A(2*i-1,2)=dif_x_h2;
        A(2*i-1,3)=dif_x_h3;
        A(2*i-1,4)=dif_x_h4;
        A(2*i-1,5)=dif_x_h5;
        A(2*i-1,6)=dif_x_h6;
        A(2*i-1,7)=dif_x_h7;
        A(2*i-1,8)=dif_x_h8;
        
        A(2*i,1)=dif_y_h1;
        A(2*i,2)=dif_y_h2;
        A(2*i,3)=dif_y_h3;
        A(2*i,4)=dif_y_h4;
        A(2*i,5)=dif_y_h5;
        A(2*i,6)=dif_y_h6;
        A(2*i,7)=dif_y_h7;
        A(2*i,8)=dif_y_h8;
        
        % Observation Matrix
        tempX=(h(1)*x+h(2)*y+h(3))/(h(7)*x+h(8)*y+1);
        tempY=(h(4)*x+h(5)*y+h(6))/(h(7)*x+h(8)*y+1);


        L(2*i-1,1)=Xground(i,1)-tempX;
        L(2*i,1)=Xground(i,2)-tempY;

    end

    % Least Squares Solution
    dX=inv(A'*A)*(A'*L);
    v=L-A*dX;
    so2=sqrt(v'*v/(2*size(ximage,1)-8));
    h=h+dX;
    iter=iter+1;
    
end
so=so2;
VV=so^2*inv(A'*A);
h(9,1)=1;
H=reshape(h,3,3)';

