function im_rect=rectify_image(im, H, pixel_size)

h = msgbox('Please wait...');

region=[1,1; size(im,2),1; size(im,2),size(im,1); 1,size(im,1)];

region(:,3)=1;

ground_region=H*region';

ground_region(1,:)=ground_region(1,:)./ground_region(3,:);
ground_region(2,:)=ground_region(2,:)./ground_region(3,:);
ground_region(3,:)=[];

minx=min(ground_region(1,:));
miny=min(ground_region(2,:));
maxx=max(ground_region(1,:));
maxy=max(ground_region(2,:));

[xi,yi] = meshgrid(minx:pixel_size:maxx,maxy:-pixel_size:miny);

width=size(xi,2);
height=size(xi,1);

sxy = homoTrans(inv(H), [xi(:)'; yi(:)'; ones(1,width*height)]);

xi = reshape(sxy(1,:),height,width);
yi = reshape(sxy(2,:),height,width);

[x,y] = meshgrid(floor(min(region(:,1))):ceil(max(region(:,1))),floor(min(region(:,2))):ceil(max(region(:,2))));

if size(im,3)>1
    im_rect(:,:,1) = uint8(interp2(x,y,double(im(floor(min(region(:,2))):ceil(max(region(:,2))),floor(min(region(:,1))):ceil(max(region(:,1))),1)),xi,yi));
    im_rect(:,:,2) = uint8(interp2(x,y,double(im(floor(min(region(:,2))):ceil(max(region(:,2))),floor(min(region(:,1))):ceil(max(region(:,1))),2)),xi,yi));
    im_rect(:,:,3) = uint8(interp2(x,y,double(im(floor(min(region(:,2))):ceil(max(region(:,2))),floor(min(region(:,1))):ceil(max(region(:,1))),3)),xi,yi));
else
    im_rect = uint8(interp2(x,y,double(im(floor(min(region(:,2))):ceil(max(region(:,2))),floor(min(region(:,1))):ceil(max(region(:,1))))),xi,yi));
end

close(h);
