function [rel,so,VV,v,iter]=relative(im1_pnt,im2_pnt,initial,interior,limit,maxiter)
% im1_pnt=[x1 y1;x2 y2;...;xn yn], im2_pnt=[x1' y1';x2' y2';...;xn' yn']
% rel=[by,bz,omega,phi,kappa] unknown parameters
% initial=[by,bz,omega,phi,kappa]   initial values of unknown parameters
% interior=[c1,xo1,yo1 ; c2,xo2,yo2];
% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% October 2003
% November 2004 different interiors 

iter=0;
% To enter the first loop
dX=[1+limit(1) 1+limit(1) 1+limit(2) 1+limit(2) 1+limit(2)]; 

while (max(abs(dX(1:2)))>=limit(1) | max(abs(dX(3:5)))>=limit(2))  
    if iter>=maxiter-1 
        break
    end
    
    R=R_from_angles(initial(3),initial(4),initial(5));  % angles in rad
    byy=initial(1);
    bz=initial(2);
    kappa=initial(5);
    phi=initial(4);
    omega=initial(3);
    c1=interior(1,1);
    xo1=interior(1,2);
    yo1=interior(1,3);
    c2=interior(2,1);
    xo2=interior(2,2);
    yo2=interior(2,3);
    
    for i = 1:size(im1_pnt,1);
        
        x1=im1_pnt(i,1);
        y1=im1_pnt(i,2);
        x2=im2_pnt(i,1);
        y2=im2_pnt(i,2);
        
        difx1=(bz*sin(kappa)*cos(omega)+bz*cos(kappa)*sin(phi)*sin(omega)-byy*sin(kappa)*sin(omega)+byy*cos(kappa)*sin(phi)*cos(omega))*x2+bz*cos(phi)*sin(omega)*c2-byy*cos(kappa)*sin(phi)*cos(omega)*xo2-bz*cos(kappa)*sin(phi)*sin(omega)*xo2+byy*sin(kappa)*sin(omega)*xo2-byy*sin(kappa)*sin(phi)*cos(omega)*y2+byy*sin(kappa)*sin(phi)*cos(omega)*yo2-byy*cos(kappa)*sin(omega)*y2+byy*cos(kappa)*sin(omega)*yo2+byy*cos(phi)*cos(omega)*c2+bz*sin(kappa)*sin(phi)*sin(omega)*yo2-bz*sin(kappa)*cos(omega)*xo2+bz*cos(kappa)*cos(omega)*y2-bz*cos(kappa)*cos(omega)*yo2-bz*sin(kappa)*sin(phi)*sin(omega)*y2;
        dify1=(-cos(kappa)*sin(phi)*cos(omega)-bz*cos(kappa)*cos(phi)+sin(kappa)*sin(omega))*x2+bz*sin(phi)*c2-sin(kappa)*sin(omega)*xo2+cos(kappa)*sin(omega)*y2-cos(kappa)*sin(omega)*yo2-cos(phi)*cos(omega)*c2+sin(kappa)*sin(phi)*cos(omega)*y2+bz*sin(kappa)*cos(phi)*y2+cos(kappa)*sin(phi)*cos(omega)*xo2-sin(kappa)*sin(phi)*cos(omega)*yo2+bz*cos(kappa)*cos(phi)*xo2-bz*sin(kappa)*cos(phi)*yo2;
        difx2=(byy*cos(kappa)*sin(phi)*cos(omega)-byy*sin(kappa)*sin(omega)+bz*cos(kappa)*sin(phi)*sin(omega)+bz*sin(kappa)*cos(omega))*x1+y1*sin(kappa)*sin(omega)-yo1*sin(kappa)*sin(omega)+c1*sin(kappa)*cos(omega)-y1*cos(kappa)*sin(phi)*cos(omega)+yo1*cos(kappa)*sin(phi)*cos(omega)+c1*cos(kappa)*sin(phi)*sin(omega)-bz*xo1*cos(kappa)*sin(phi)*sin(omega)+bz*cos(kappa)*cos(phi)*yo1-byy*c1*cos(kappa)*cos(phi)-bz*xo1*sin(kappa)*cos(omega)-byy*xo1*cos(kappa)*sin(phi)*cos(omega)+byy*xo1*sin(kappa)*sin(omega)-bz*cos(kappa)*cos(phi)*y1;
        dify2=(-byy*cos(kappa)*sin(omega)-byy*sin(kappa)*sin(phi)*cos(omega)-bz*sin(kappa)*sin(phi)*sin(omega)+bz*cos(kappa)*cos(omega))*x1+y1*cos(kappa)*sin(omega)-yo1*cos(kappa)*sin(omega)+c1*cos(kappa)*cos(omega)+y1*sin(kappa)*sin(phi)*cos(omega)-yo1*sin(kappa)*sin(phi)*cos(omega)-c1*sin(kappa)*sin(phi)*sin(omega)+bz*xo1*sin(kappa)*sin(phi)*sin(omega)+bz*sin(kappa)*cos(phi)*y1-bz*sin(kappa)*cos(phi)*yo1-bz*xo1*cos(kappa)*cos(omega)+byy*xo1*sin(kappa)*sin(phi)*cos(omega)+byy*c1*sin(kappa)*cos(phi)+byy*xo1*cos(kappa)*sin(omega);
        difbyy=(cos(kappa)*sin(phi)*cos(omega)*x2-sin(kappa)*sin(omega)*x2+sin(kappa)*sin(omega)*xo2-sin(kappa)*sin(phi)*cos(omega)*y2-cos(kappa)*sin(phi)*cos(omega)*xo2-cos(kappa)*sin(omega)*y2+cos(kappa)*sin(omega)*yo2+cos(phi)*cos(omega)*c2+sin(kappa)*sin(phi)*cos(omega)*yo2)*x1+xo1*sin(kappa)*sin(phi)*cos(omega)*y2+c1*sin(phi)*c2-xo1*sin(kappa)*sin(phi)*cos(omega)*yo2+xo1*cos(kappa)*sin(omega)*y2-xo1*cos(kappa)*sin(omega)*yo2-xo1*cos(phi)*cos(omega)*c2-c1*cos(kappa)*cos(phi)*x2+c1*cos(kappa)*cos(phi)*xo2+c1*sin(kappa)*cos(phi)*y2-xo1*cos(kappa)*sin(phi)*cos(omega)*x2+xo1*cos(kappa)*sin(phi)*cos(omega)*xo2+xo1*sin(kappa)*sin(omega)*x2-xo1*sin(kappa)*sin(omega)*xo2-c1*sin(kappa)*cos(phi)*yo2;
        difbz=(sin(kappa)*cos(omega)*x2+cos(phi)*sin(omega)*c2+cos(kappa)*sin(phi)*sin(omega)*x2-cos(kappa)*sin(phi)*sin(omega)*xo2-sin(kappa)*sin(phi)*sin(omega)*y2+cos(kappa)*cos(omega)*y2-cos(kappa)*cos(omega)*yo2+sin(kappa)*sin(phi)*sin(omega)*yo2-sin(kappa)*cos(omega)*xo2)*x1+sin(phi)*c2*y1-sin(phi)*c2*yo1+sin(kappa)*cos(phi)*yo2*yo1+xo1*sin(kappa)*sin(phi)*sin(omega)*y2-xo1*sin(kappa)*cos(omega)*x2+xo1*sin(kappa)*cos(omega)*xo2+xo1*cos(kappa)*cos(omega)*yo2-xo1*sin(kappa)*sin(phi)*sin(omega)*yo2+cos(kappa)*cos(phi)*x2*yo1+cos(kappa)*cos(phi)*xo2*y1+xo1*cos(kappa)*sin(phi)*sin(omega)*xo2-xo1*cos(phi)*sin(omega)*c2-cos(kappa)*cos(phi)*x2*y1+sin(kappa)*cos(phi)*y2*y1-sin(kappa)*cos(phi)*yo2*y1-cos(kappa)*cos(phi)*xo2*yo1-xo1*cos(kappa)*sin(phi)*sin(omega)*x2-xo1*cos(kappa)*cos(omega)*y2-sin(kappa)*cos(phi)*y2*yo1;
        difkappa=byy*xo1*cos(kappa)*sin(omega)*x2-byy*xo1*cos(kappa)*sin(omega)*xo2+byy*xo1*cos(kappa)*sin(phi)*cos(omega)*y2+yo1*sin(kappa)*sin(phi)*cos(omega)*xo2-yo1*cos(kappa)*sin(phi)*cos(omega)*y2+yo1*cos(kappa)*sin(phi)*cos(omega)*yo2-c1*sin(kappa)*sin(phi)*sin(omega)*x2+c1*sin(kappa)*sin(phi)*sin(omega)*xo2-c1*cos(kappa)*sin(phi)*sin(omega)*y2-bz*cos(kappa)*cos(phi)*y2*yo1-bz*cos(kappa)*cos(phi)*yo2*y1+y1*sin(kappa)*sin(omega)*yo2-yo1*cos(kappa)*sin(omega)*x2+yo1*cos(kappa)*sin(omega)*xo2+yo1*sin(kappa)*sin(omega)*y2-yo1*sin(kappa)*sin(omega)*yo2+bz*sin(kappa)*cos(phi)*x2*y1-bz*xo1*cos(kappa)*sin(phi)*sin(omega)*yo2-bz*sin(kappa)*cos(phi)*x2*yo1-bz*sin(kappa)*cos(phi)*xo2*y1+bz*sin(kappa)*cos(phi)*xo2*yo1+bz*cos(kappa)*cos(phi)*y2*y1-bz*xo1*cos(kappa)*cos(omega)*x2+bz*xo1*cos(kappa)*cos(omega)*xo2+bz*xo1*sin(kappa)*cos(omega)*y2+y1*cos(kappa)*sin(phi)*cos(omega)*y2-bz*xo1*sin(kappa)*cos(omega)*yo2-byy*c1*sin(kappa)*cos(phi)*xo2+byy*c1*cos(kappa)*cos(phi)*y2-byy*c1*cos(kappa)*cos(phi)*yo2+bz*cos(kappa)*cos(phi)*yo2*yo1+(-bz*cos(kappa)*sin(phi)*sin(omega)*y2-bz*sin(kappa)*cos(omega)*y2+byy*cos(kappa)*sin(omega)*xo2-byy*sin(kappa)*sin(phi)*cos(omega)*x2-byy*cos(kappa)*sin(omega)*x2-byy*cos(kappa)*sin(phi)*cos(omega)*y2-bz*sin(kappa)*sin(phi)*sin(omega)*x2+byy*cos(kappa)*sin(phi)*cos(omega)*yo2+byy*sin(kappa)*sin(omega)*y2-byy*sin(kappa)*sin(omega)*yo2+bz*sin(kappa)*cos(omega)*yo2-bz*cos(kappa)*cos(omega)*xo2+bz*cos(kappa)*cos(omega)*x2+byy*sin(kappa)*sin(phi)*cos(omega)*xo2+bz*sin(kappa)*sin(phi)*sin(omega)*xo2+bz*cos(kappa)*sin(phi)*sin(omega)*yo2)*x1+y1*sin(kappa)*sin(phi)*cos(omega)*x2-y1*sin(kappa)*sin(phi)*cos(omega)*xo2-y1*cos(kappa)*sin(phi)*cos(omega)*yo2-yo1*sin(kappa)*sin(phi)*cos(omega)*x2+y1*cos(kappa)*sin(omega)*x2-y1*cos(kappa)*sin(omega)*xo2-y1*sin(kappa)*sin(omega)*y2+c1*cos(kappa)*sin(phi)*sin(omega)*yo2+bz*xo1*sin(kappa)*sin(phi)*sin(omega)*x2-bz*xo1*sin(kappa)*sin(phi)*sin(omega)*xo2+bz*xo1*cos(kappa)*sin(phi)*sin(omega)*y2-byy*xo1*cos(kappa)*sin(phi)*cos(omega)*yo2-byy*xo1*sin(kappa)*sin(omega)*y2+byy*xo1*sin(kappa)*sin(omega)*yo2+byy*c1*sin(kappa)*cos(phi)*x2+c1*cos(kappa)*cos(omega)*x2-c1*cos(kappa)*cos(omega)*xo2-c1*sin(kappa)*cos(omega)*y2+c1*sin(kappa)*cos(omega)*yo2+byy*xo1*sin(kappa)*sin(phi)*cos(omega)*x2-byy*xo1*sin(kappa)*sin(phi)*cos(omega)*xo2;
        difphi=-byy*xo1*sin(kappa)*cos(phi)*cos(omega)*yo2+byy*xo1*sin(phi)*cos(omega)*c2+byy*c1*cos(kappa)*sin(phi)*x2+byy*xo1*cos(kappa)*cos(phi)*cos(omega)*xo2+byy*xo1*sin(kappa)*cos(phi)*cos(omega)*y2+bz*xo1*sin(phi)*sin(omega)*c2-bz*cos(kappa)*sin(phi)*xo2*y1+bz*cos(kappa)*sin(phi)*xo2*yo1-bz*sin(kappa)*sin(phi)*y2*y1-yo1*sin(phi)*cos(omega)*c2-c1*sin(phi)*sin(omega)*c2-byy*c1*cos(kappa)*sin(phi)*xo2-byy*c1*sin(kappa)*sin(phi)*y2+bz*cos(phi)*c2*y1+(-bz*cos(kappa)*cos(phi)*sin(omega)*xo2+byy*cos(kappa)*cos(phi)*cos(omega)*x2+bz*cos(kappa)*cos(phi)*sin(omega)*x2-byy*sin(phi)*cos(omega)*c2-bz*sin(phi)*sin(omega)*c2-byy*sin(kappa)*cos(phi)*cos(omega)*y2+byy*sin(kappa)*cos(phi)*cos(omega)*yo2-bz*sin(kappa)*cos(phi)*sin(omega)*y2-byy*cos(kappa)*cos(phi)*cos(omega)*xo2+bz*sin(kappa)*cos(phi)*sin(omega)*yo2)*x1+bz*sin(kappa)*sin(phi)*y2*yo1+bz*sin(kappa)*sin(phi)*yo2*y1+byy*c1*sin(kappa)*sin(phi)*yo2-bz*sin(kappa)*sin(phi)*yo2*yo1+y1*cos(kappa)*cos(phi)*cos(omega)*xo2-y1*sin(kappa)*cos(phi)*cos(omega)*yo2+yo1*cos(kappa)*cos(phi)*cos(omega)*x2+y1*sin(kappa)*cos(phi)*cos(omega)*y2-y1*cos(kappa)*cos(phi)*cos(omega)*x2-yo1*cos(kappa)*cos(phi)*cos(omega)*xo2-yo1*sin(kappa)*cos(phi)*cos(omega)*y2+yo1*sin(kappa)*cos(phi)*cos(omega)*yo2+c1*cos(kappa)*cos(phi)*sin(omega)*x2-c1*cos(kappa)*cos(phi)*sin(omega)*xo2-bz*cos(phi)*c2*yo1-byy*xo1*cos(kappa)*cos(phi)*cos(omega)*x2+bz*cos(kappa)*sin(phi)*x2*y1+y1*sin(phi)*cos(omega)*c2-c1*sin(kappa)*cos(phi)*sin(omega)*y2+c1*sin(kappa)*cos(phi)*sin(omega)*yo2-bz*xo1*cos(kappa)*cos(phi)*sin(omega)*x2+bz*xo1*cos(kappa)*cos(phi)*sin(omega)*xo2+byy*c1*cos(phi)*c2+bz*xo1*sin(kappa)*cos(phi)*sin(omega)*y2-bz*xo1*sin(kappa)*cos(phi)*sin(omega)*yo2-bz*cos(kappa)*sin(phi)*x2*yo1;
        difomega=y1*sin(kappa)*cos(omega)*x2-y1*sin(kappa)*cos(omega)*xo2+y1*cos(kappa)*cos(omega)*y2-y1*cos(kappa)*cos(omega)*yo2+y1*cos(phi)*sin(omega)*c2-yo1*sin(kappa)*cos(omega)*x2+yo1*sin(kappa)*cos(omega)*xo2-yo1*cos(kappa)*cos(omega)*y2+yo1*cos(kappa)*cos(omega)*yo2-y1*sin(kappa)*sin(phi)*sin(omega)*y2+y1*cos(kappa)*sin(phi)*sin(omega)*x2-yo1*cos(phi)*sin(omega)*c2-c1*sin(kappa)*sin(omega)*x2+c1*sin(kappa)*sin(omega)*xo2-c1*cos(kappa)*sin(omega)*y2+c1*cos(kappa)*sin(omega)*yo2+c1*cos(phi)*cos(omega)*c2-y1*cos(kappa)*sin(phi)*sin(omega)*xo2+y1*sin(kappa)*sin(phi)*sin(omega)*yo2-yo1*cos(kappa)*sin(phi)*sin(omega)*x2+yo1*cos(kappa)*sin(phi)*sin(omega)*xo2+yo1*sin(kappa)*sin(phi)*sin(omega)*y2-yo1*sin(kappa)*sin(phi)*sin(omega)*yo2+c1*cos(kappa)*sin(phi)*cos(omega)*x2+(bz*cos(kappa)*sin(phi)*cos(omega)*x2-byy*cos(kappa)*sin(phi)*sin(omega)*x2-byy*cos(kappa)*cos(omega)*y2-bz*cos(kappa)*sin(omega)*y2+bz*sin(kappa)*sin(phi)*cos(omega)*yo2-byy*sin(kappa)*cos(omega)*x2-byy*cos(phi)*sin(omega)*c2+byy*sin(kappa)*cos(omega)*xo2+byy*sin(kappa)*sin(phi)*sin(omega)*y2+byy*cos(kappa)*cos(omega)*yo2+byy*cos(kappa)*sin(phi)*sin(omega)*xo2+bz*cos(kappa)*sin(omega)*yo2+bz*cos(phi)*cos(omega)*c2-bz*sin(kappa)*sin(omega)*x2+bz*sin(kappa)*sin(omega)*xo2-bz*cos(kappa)*sin(phi)*cos(omega)*xo2-bz*sin(kappa)*sin(phi)*cos(omega)*y2-byy*sin(kappa)*sin(phi)*sin(omega)*yo2)*x1-bz*xo1*cos(kappa)*sin(phi)*cos(omega)*x2+bz*xo1*cos(kappa)*sin(phi)*cos(omega)*xo2+bz*xo1*sin(kappa)*sin(phi)*cos(omega)*y2-c1*cos(kappa)*sin(phi)*cos(omega)*xo2-c1*sin(kappa)*sin(phi)*cos(omega)*y2+c1*sin(kappa)*sin(phi)*cos(omega)*yo2+byy*xo1*cos(kappa)*sin(phi)*sin(omega)*x2-byy*xo1*cos(kappa)*sin(phi)*sin(omega)*xo2-bz*xo1*sin(kappa)*sin(phi)*cos(omega)*yo2+byy*xo1*sin(kappa)*cos(omega)*x2-byy*xo1*sin(kappa)*cos(omega)*xo2-byy*xo1*sin(kappa)*sin(phi)*sin(omega)*y2+bz*xo1*sin(kappa)*sin(omega)*x2-bz*xo1*sin(kappa)*sin(omega)*xo2+byy*xo1*cos(phi)*sin(omega)*c2+byy*xo1*sin(kappa)*sin(phi)*sin(omega)*yo2+byy*xo1*cos(kappa)*cos(omega)*y2-byy*xo1*cos(kappa)*cos(omega)*yo2+bz*xo1*cos(kappa)*sin(omega)*y2-bz*xo1*cos(kappa)*sin(omega)*yo2-bz*xo1*cos(phi)*cos(omega)*c2;
       
        A(i,1)=difbyy;
        A(i,2)=difbz;
        A(i,3)=difomega;
        A(i,4)=difphi;
        A(i,5)=difkappa;
        
        Ba(i,2*i-1)=difx1;
        Ba(i,2*i)=dify1;
        
        Bb(i,2*i-1)=difx2;
        Bb(i,2*i)=dify2;
        
        temp=R'*[x2-xo2 y2-yo2 -c2]';
        W(i)=det([        1           byy           bz
                     x1-xo1        y1-yo1          -c1
                    temp(1)        temp(2)      temp(3)]);
    end    
    
    
    B=[Ba Bb];
    MM=B*B';
    M=inv(MM);
    dX=-inv(A'*M*A)*A'*M*W';
    initial=initial+dX';
    iter=iter+1;
end
rel=dX'+initial;
v=B'*M*(W'+A*dX);
so=sqrt(v'*v/(size(im1_pnt,1)-5));
VV=so^2*inv(A'*M*A);

