function [exterior,interior,so,VV,v,iter]=resection_interior_radial(exterior_initial,interior_initial,ximage,Xground,limit,maxiter)

% exterior=[Xo Yo Zo omega phi kappa]
% interior_initial=[c xo yo k1 k2]
% ximage=[x1 y1;x2 y2;...;xn yn]
% Xground=[X1 Y1 Z1;...;Xn Yn Zn]
% limit=[linear angular interior] convergence limits ie:[0.001(m) 0.000001(rad) 0.001(mm)]
% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% October 2003


interior=interior_initial';
exterior=exterior_initial';
iter=0;
% To enter the first loop
dX=[1+limit(1) 1+limit(1) 1+limit(1) 1+limit(2) 1+limit(2) 1+limit(2) 1+limit(3) 1+limit(3) 1+limit(3) 1+limit(3) 1+limit(3)]; 

while max(abs(dX(1:3)))>=limit(2) | max(abs(dX(4:6)))>=limit(2) | max(abs(dX(7:9)))>=limit(3) 
    if iter>=maxiter-1 
        break
    end
    Xo=exterior(1); 
    Yo=exterior(2); 
    Zo=exterior(3); 
    omega=exterior(4); 
    phi=exterior(5); 
    kappa=exterior(6);
    c=interior(1);
    xo=interior(2);
    yo=interior(3);
    k1=interior(4);
    k2=interior(5);
    
    for i=1:size(ximage,1)
        
        X=Xground(i,1);
        Y=Xground(i,2);
        Z=Xground(i,3);

        
        distr2=((ximage(i,1)-xo)^2+(ximage(i,2)-yo)^2);
        distdx=(ximage(i,1)-xo)*((k1*distr2)+(k2*(distr2)^2));
        distdy=(ximage(i,2)-yo)*((k1*distr2)+(k2*(distr2)^2));

        % Observation Matrix
        [tempx,tempy]=colinearity_radial(c,xo,yo,k1,k2,Xo,Yo,Zo,omega,phi,kappa,X,Y,Z);
        %[tempx,tempy]=colinearity(c,xo,yo,Xo,Yo,Zo,omega,phi,kappa,X,Y,Z);
        L(2*i-1,1)=ximage(i,1)-tempx;%-distdx;
        L(2*i,1)=ximage(i,2)-tempy;%-distdy;

        difx_Xo=c*cos(kappa)*cos(phi)/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))-c*(cos(kappa)*cos(phi)*(X-Xo)+(cos(kappa)*sin(phi)*sin(omega)+sin(kappa)*cos(omega))*(Y-Yo)+(-cos(kappa)*sin(phi)*cos(omega)+sin(kappa)*sin(omega))*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))^2*sin(phi);
        dify_Xo=-c*sin(kappa)*cos(phi)/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))-c*(-sin(kappa)*cos(phi)*(X-Xo)+(-sin(kappa)*sin(phi)*sin(omega)+cos(kappa)*cos(omega))*(Y-Yo)+(sin(kappa)*sin(phi)*cos(omega)+cos(kappa)*sin(omega))*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))^2*sin(phi);
        difx_Yo=-c*(-cos(kappa)*sin(phi)*sin(omega)-sin(kappa)*cos(omega))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))+c*(cos(kappa)*cos(phi)*(X-Xo)+(cos(kappa)*sin(phi)*sin(omega)+sin(kappa)*cos(omega))*(Y-Yo)+(-cos(kappa)*sin(phi)*cos(omega)+sin(kappa)*sin(omega))*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))^2*cos(phi)*sin(omega);
        dify_Yo=-c*(sin(kappa)*sin(phi)*sin(omega)-cos(kappa)*cos(omega))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))+c*(-sin(kappa)*cos(phi)*(X-Xo)+(-sin(kappa)*sin(phi)*sin(omega)+cos(kappa)*cos(omega))*(Y-Yo)+(sin(kappa)*sin(phi)*cos(omega)+cos(kappa)*sin(omega))*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))^2*cos(phi)*sin(omega);
        difx_Zo=-c*(cos(kappa)*sin(phi)*cos(omega)-sin(kappa)*sin(omega))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))-c*(cos(kappa)*cos(phi)*(X-Xo)+(cos(kappa)*sin(phi)*sin(omega)+sin(kappa)*cos(omega))*(Y-Yo)+(-cos(kappa)*sin(phi)*cos(omega)+sin(kappa)*sin(omega))*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))^2*cos(phi)*cos(omega);
        dify_Zo=-c*(-sin(kappa)*sin(phi)*cos(omega)-cos(kappa)*sin(omega))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))-c*(-sin(kappa)*cos(phi)*(X-Xo)+(-sin(kappa)*sin(phi)*sin(omega)+cos(kappa)*cos(omega))*(Y-Yo)+(sin(kappa)*sin(phi)*cos(omega)+cos(kappa)*sin(omega))*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))^2*cos(phi)*cos(omega);
        difx_omega=-c*((cos(kappa)*sin(phi)*cos(omega)-sin(kappa)*sin(omega))*(Y-Yo)+(cos(kappa)*sin(phi)*sin(omega)+sin(kappa)*cos(omega))*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))+c*(cos(kappa)*cos(phi)*(X-Xo)+(cos(kappa)*sin(phi)*sin(omega)+sin(kappa)*cos(omega))*(Y-Yo)+(-cos(kappa)*sin(phi)*cos(omega)+sin(kappa)*sin(omega))*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))^2*(-cos(phi)*cos(omega)*(Y-Yo)-cos(phi)*sin(omega)*(Z-Zo));
        dify_omega=-c*((-sin(kappa)*sin(phi)*cos(omega)-cos(kappa)*sin(omega))*(Y-Yo)+(-sin(kappa)*sin(phi)*sin(omega)+cos(kappa)*cos(omega))*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))+c*(-sin(kappa)*cos(phi)*(X-Xo)+(-sin(kappa)*sin(phi)*sin(omega)+cos(kappa)*cos(omega))*(Y-Yo)+(sin(kappa)*sin(phi)*cos(omega)+cos(kappa)*sin(omega))*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))^2*(-cos(phi)*cos(omega)*(Y-Yo)-cos(phi)*sin(omega)*(Z-Zo));
        difx_phi=-c*(-cos(kappa)*sin(phi)*(X-Xo)+cos(kappa)*cos(phi)*sin(omega)*(Y-Yo)-cos(kappa)*cos(phi)*cos(omega)*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))+c*(cos(kappa)*cos(phi)*(X-Xo)+(cos(kappa)*sin(phi)*sin(omega)+sin(kappa)*cos(omega))*(Y-Yo)+(-cos(kappa)*sin(phi)*cos(omega)+sin(kappa)*sin(omega))*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))^2*(cos(phi)*(X-Xo)+sin(phi)*sin(omega)*(Y-Yo)-sin(phi)*cos(omega)*(Z-Zo));
        dify_phi=-c*(sin(kappa)*sin(phi)*(X-Xo)-sin(kappa)*cos(phi)*sin(omega)*(Y-Yo)+sin(kappa)*cos(phi)*cos(omega)*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))+c*(-sin(kappa)*cos(phi)*(X-Xo)+(-sin(kappa)*sin(phi)*sin(omega)+cos(kappa)*cos(omega))*(Y-Yo)+(sin(kappa)*sin(phi)*cos(omega)+cos(kappa)*sin(omega))*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo))^2*(cos(phi)*(X-Xo)+sin(phi)*sin(omega)*(Y-Yo)-sin(phi)*cos(omega)*(Z-Zo));
        difx_kappa=-c*(-sin(kappa)*cos(phi)*(X-Xo)+(-sin(kappa)*sin(phi)*sin(omega)+cos(kappa)*cos(omega))*(Y-Yo)+(sin(kappa)*sin(phi)*cos(omega)+cos(kappa)*sin(omega))*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo));
        dify_kappa=-c*(-cos(kappa)*cos(phi)*(X-Xo)+(-cos(kappa)*sin(phi)*sin(omega)-sin(kappa)*cos(omega))*(Y-Yo)+(cos(kappa)*sin(phi)*cos(omega)-sin(kappa)*sin(omega))*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo));
        difx_c=-(cos(kappa)*cos(phi)*(X-Xo)+(cos(kappa)*sin(phi)*sin(omega)+sin(kappa)*cos(omega))*(Y-Yo)+(-cos(kappa)*sin(phi)*cos(omega)+sin(kappa)*sin(omega))*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo));
        dify_c=-(-sin(kappa)*cos(phi)*(X-Xo)+(-sin(kappa)*sin(phi)*sin(omega)+cos(kappa)*cos(omega))*(Y-Yo)+(sin(kappa)*sin(phi)*cos(omega)+cos(kappa)*sin(omega))*(Z-Zo))/(sin(phi)*(X-Xo)-cos(phi)*sin(omega)*(Y-Yo)+cos(phi)*cos(omega)*(Z-Zo));
        difx_xo=1;
        dify_xo=0;
        difx_yo=0;
        dify_yo=1;
        difx_k1=distr2*(ximage(i,1)-xo);
        dify_k1=distr2*(ximage(i,2)-yo);
        difx_k2=distr2^2*(ximage(i,1)-xo);
        dify_k2=distr2^2*(ximage(i,2)-yo);
        
        
        % Design Matrix A
        A(2*i-1,1)=difx_Xo;
        A(2*i-1,2)=difx_Yo;
        A(2*i-1,3)=difx_Zo;
        A(2*i-1,4)=difx_omega;
        A(2*i-1,5)=difx_phi;
        A(2*i-1,6)=difx_kappa;
        A(2*i-1,7)=difx_c;
        A(2*i-1,8)=difx_xo;
        A(2*i-1,9)=difx_yo;
        A(2*i-1,10)=difx_k1;
        A(2*i-1,11)=difx_k2;

        A(2*i,1)=dify_Xo;
        A(2*i,2)=dify_Yo;
        A(2*i,3)=dify_Zo;
        A(2*i,4)=dify_omega;
        A(2*i,5)=dify_phi;
        A(2*i,6)=dify_kappa;
        A(2*i,7)=dify_c;
        A(2*i,8)=dify_xo;
        A(2*i,9)=dify_yo;
        A(2*i,10)=dify_xo;
        A(2*i,11)=dify_yo;

        
    end
    
    % Least Squares Solution
    
    dX=inv(A'*A)*(A'*L);
    exterior=exterior+dX(1:6);
    interior=interior+dX(7:11);
    iter=iter+1;
end

v=L-A*dX;
if size(ximage,1)>6
    so=sqrt(v'*v/(2*size(ximage,1)-11));
    VV=so^2*inv(A'*A);
else 
    so=[];
    VV=[];
end