function show_DLT_results_radial(im_name,control_image,P,interior,exterior,err,so,v,iter)
% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% December 2004

clc;
fprintf('Matlab Photogrammetric Toolbox by PCVG\n');
fprintf('\n');
fprintf('DLT Results:\n');
fprintf('\n');
fprintf('Image: %s \n',im_name);
fprintf('\n');
fprintf('DLT Coefficients:\n');
fprintf('P1  = %f   %f \n',P(1,1),err(1));
fprintf('P2  = %f   %f \n',P(1,2),err(2));
fprintf('P3  = %f   %f \n',P(1,3),err(3));
fprintf('P4  = %f   %f \n',P(1,4),err(4));
fprintf('P5  = %f   %f \n',P(2,1),err(5));
fprintf('P6  = %f   %f \n',P(2,2),err(6));
fprintf('P7  = %f   %f \n',P(2,3),err(7));
fprintf('P8  = %f   %f \n',P(2,4),err(8));
fprintf('P9  = %f   %f \n',P(3,1),err(9));
fprintf('P10 = %f   %f \n',P(3,2),err(10));
fprintf('P11 = %f   %f \n',P(3,3),err(11));
fprintf('P12 = %f  \n',1);
fprintf('\n');
fprintf('Iterations: %d  \n',iter);
fprintf('\n');
fprintf('sigma = %f  \n',so);
fprintf('\n');
fprintf('Derived Interior Orientation:\n');
fprintf('c = %f  \n',interior(1));
fprintf('xo = %f \n',interior(2));
fprintf('yo = %f \n',interior(3));
fprintf('Computed Radial Distortion: \n');
fprintf('k1 = %e  %e \n',interior(4),err(12));
fprintf('k2 = %e  %e \n',interior(5),err(13));
fprintf('NOTE: Interior Orientation Parameters are now updated!\n');
fprintf('\n');
fprintf('Derived Exterior Orientation:\n');
fprintf('Xo = %f  \n',exterior(1));
fprintf('Yo = %f  \n',exterior(2));
fprintf('Zo = %f  \n',exterior(3));
fprintf('omega = %f deg  \n',exterior(4)*180/pi);
fprintf('phi = %f deg  \n',exterior(5)*180/pi);
fprintf('kappa = %f deg  \n',exterior(6)*180/pi);
fprintf('\n');
fprintf('Image Residuals:\n');
for i=1:size(v,1)/2
    fprintf('%g  %f  %f\n',control_image(i,1),v(2*i-1),v(2*i));
end
