function show_absolute_results(im_names,model,exterior_left,exterior_right,absol,err,so,v,iter)
% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% October 2003

clc;
fprintf('Matlab Photogrammetric Toolbox by PCVG\n');
fprintf('\n');
fprintf('Absolute Orientation Results:\n');
fprintf('Image1: %s \n',im_names{1});
fprintf('Image2: %s \n',im_names{2});
fprintf('\n');
fprintf('Absolute Orientation Parameters:\n');
fprintf('k = %f   %f\n',absol(1),err(1));
fprintf('OMEGA = %f deg   %f deg\n',absol(2)*180/pi,err(2)*180/pi);
fprintf('PHI = %f deg   %f deg\n',absol(3)*180/pi,err(3)*180/pi);
fprintf('KAPPA = %f deg   %f deg\n',absol(4)*180/pi,err(4)*180/pi);
fprintf('tx = %f   %f\n',absol(5),err(5));
fprintf('ty = %f   %f \n',absol(6),err(6));
fprintf('tz = %f   %f \n',absol(7),err(7));
fprintf('\n');
fprintf('Iterations: %d  \n',iter);
fprintf('\n');
fprintf('sigma = %f  \n',so);
fprintf('\n');
fprintf('Object Space Residuals:\n');
for i=1:size(v,1)/3
    fprintf('%g  %f  %f  %f\n',model(i,1),v(3*i-2),v(3*i-1),v(3*i));
end
fprintf('\n');
fprintf('Image1 Derived Exterior Orientation:\n');
fprintf('\n');
fprintf('Xo = %f \n',exterior_left(1));
fprintf('Yo = %f   \n',exterior_left(2));
fprintf('Zo = %f   \n',exterior_left(3));
fprintf('omega = %f deg  \n',exterior_left(4)*180/pi);
fprintf('phi = %f deg  \n',exterior_left(5)*180/pi);
fprintf('kappa = %f deg  \n',exterior_left(6)*180/pi);
fprintf('\n');
fprintf('Image2 Derived Exterior Orientation:\n');
fprintf('\n');
fprintf('Xo = %f \n',exterior_right(1));
fprintf('Yo = %f   \n',exterior_right(2));
fprintf('Zo = %f   \n',exterior_right(3));
fprintf('omega = %f deg  \n',exterior_right(4)*180/pi);
fprintf('phi = %f deg  \n',exterior_right(5)*180/pi);
fprintf('kappa = %f deg  \n',exterior_right(6)*180/pi);

