function show_resection_interior_results_radial(im_name,control_image,interior,exterior,err,so,v,iter)
% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% October 2003

clc;
fprintf('Matlab Photogrammetric Toolbox by PCVG\n');
fprintf('\n');
fprintf('Resection with Interior Orientation Results:\n');
fprintf('\n');
fprintf('Image: %s \n',im_name);
fprintf('\n');
fprintf('Interior Orientation Parameters:\n');
fprintf('c = %f   %f\n',interior(1),err(7));
fprintf('xo = %f   %f \n',interior(2),err(8));
fprintf('yo = %f   %f \n',interior(3),err(9));
fprintf('k1 = %e   %e \n',interior(4),err(10));
fprintf('k2 = %e   %e \n',interior(5),err(11));
fprintf('NOTE: Interior Orientation Parameters are now updated!\n');
fprintf('\n');
fprintf('Exterior Orientation Parameters:\n');
fprintf('Xo = %f   %f\n',exterior(1),err(1));
fprintf('Yo = %f   %f \n',exterior(2),err(2));
fprintf('Zo = %f   %f \n',exterior(3),err(3));
fprintf('omega = %f deg   %f deg\n',exterior(4)*180/pi,err(4)*180/pi);
fprintf('phi = %f deg   %f deg\n',exterior(5)*180/pi,err(5)*180/pi);
fprintf('kappa = %f deg   %f deg\n',exterior(6)*180/pi,err(6)*180/pi);
fprintf('\n');
fprintf('Iterations: %d  \n',iter);
fprintf('\n');
fprintf('sigma = %f  \n',so);
fprintf('\n');
fprintf('Residuals:\n');
for i=1:size(v,1)/2
    fprintf('%g  %f  %f\n',control_image(i,1),v(2*i-1),v(2*i));
end
