function lines_matrix_affine=tranform_measured_lines(affine_results,lines_matrix,interior)
% lines_matrix=[image_number    line_id    line_code    pnt_code   line_handle(text_handle for first point)   pnt_handle    x(pixels)    y(pixels)]
% lines_matrix_affine=[image_number  line_id    line_code   pnt_code   x(mm)    y(mm)]
% Compensates radial distortion:
% distr2=((x-xo).^2+(y-yo).^2); 
% distdx=(x-xo).*((k1*distr2)+(k2*(distr2).^2));
% distdy=(y-yo).*((k1*distr2)+(k2*(distr2).^2));
% x=x-distdx; 
% y=y-distdy; 
% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% December 2004

lines_matrix_affine=lines_matrix;
lines_matrix_affine(:,7)=affine_results(lines_matrix(:,1),1).*lines_matrix(:,7) ...
                         +affine_results(lines_matrix(:,1),2).*lines_matrix(:,8) ...
                         +affine_results(lines_matrix(:,1),3);


lines_matrix_affine(:,8)=affine_results(lines_matrix(:,1),4).*lines_matrix(:,7) ...
                         +affine_results(lines_matrix(:,1),5).*lines_matrix(:,8) ...
                         +affine_results(lines_matrix(:,1),6);

lines_matrix_affine(:,5:6)=[]; % delete point handles

% Radial Distortion
distr2=((lines_matrix_affine(:,5)-interior(lines_matrix_affine(:,1),2)).^2+...
        (lines_matrix_affine(:,6)-interior(lines_matrix_affine(:,1),3)).^2); 
distdx=(lines_matrix_affine(:,5)-interior(lines_matrix_affine(:,1),2)).*...
       ((interior(lines_matrix_affine(:,1),4).*distr2)+(interior(lines_matrix_affine(:,1),5).*((distr2).^2)));
distdy=(lines_matrix_affine(:,6)-interior(lines_matrix_affine(:,1),3)).*...
       ((interior(lines_matrix_affine(:,1),4).*distr2)+(interior(lines_matrix_affine(:,1),5).*((distr2).^2)));
lines_matrix_affine(:,5)=lines_matrix_affine(:,5)-distdx; 
lines_matrix_affine(:,6)=lines_matrix_affine(:,6)-distdy; 
 
