function points_matrix_affine=tranform_measured_points(affine_results,points_matrix,interior)
% points_matrix=[image_number  pnt_code    pnt_id   pnt_handle   text_handle    x(pixels)    y(pixels) enable]
% points_matrix_affine=[image_number  pnt_code    pnt_id    x(mm)    y(m) enable]
% Compensates radial distortion:
% distr2=((x-xo).^2+(y-yo).^2); 
% distdx=(x-xo).*((k1*distr2)+(k2*(distr2).^2));
% distdy=(y-yo).*((k1*distr2)+(k2*(distr2).^2));
% x=x-distdx; 
% y=y-distdy; 
% Author: PCVG (Lazaros Grammatikopoulos, Ilias Kalisperakis)
% November 2004

points_matrix_affine=points_matrix;
points_matrix_affine(:,6)=affine_results(points_matrix(:,1),1).*points_matrix(:,6) ...
                         +affine_results(points_matrix(:,1),2).*points_matrix(:,7) ...
                         +affine_results(points_matrix(:,1),3);


points_matrix_affine(:,7)=affine_results(points_matrix(:,1),4).*points_matrix(:,6) ...
                         +affine_results(points_matrix(:,1),5).*points_matrix(:,7) ...
                         +affine_results(points_matrix(:,1),6);

points_matrix_affine(:,4:5)=[]; % delete point handles

% Radial Distortion
distr2=((points_matrix_affine(:,4)-interior(points_matrix_affine(:,1),2)).^2+...
        (points_matrix_affine(:,5)-interior(points_matrix_affine(:,1),3)).^2); 
distdx=(points_matrix_affine(:,4)-interior(points_matrix_affine(:,1),2)).*...
       ((interior(points_matrix_affine(:,1),4).*distr2)+(interior(points_matrix_affine(:,1),5).*((distr2).^2)));
distdy=(points_matrix_affine(:,5)-interior(points_matrix_affine(:,1),3)).*...
       ((interior(points_matrix_affine(:,1),4).*distr2)+(interior(points_matrix_affine(:,1),5).*((distr2).^2)));
points_matrix_affine(:,4)=points_matrix_affine(:,4)-distdx; 
points_matrix_affine(:,5)=points_matrix_affine(:,5)-distdy; 
 
